//===============================================================
// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 610-725-8800
//-----------------------------
// Programmer: Tim Van Dusen
// Last modified: 8-29-02
// Name: VC5_APP.cpp
// Uses LL_USB2K.DLL or LL_USB.DLL
//===============================================================
  
#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>
#include "vc5_app.h"
#include "resource.h"


BOOLEAN fWin98Flag = FALSE;
BOOLEAN GetWinVerInfo();


// IMPORTANT NOTES TO PROGRAMMER: 
// See DLL Function call explanations in FuncDesc.doc. That 
//		file can be viewed with Windows WordPad.
// See important notes and update information in Notes301.doc.

// All DLL functions return BOOLEAN and also contain some
//		BOOLEAN type arguments. Note that this type is the same
//		as type "bool" but not type BOOL which is a 32-bit type.
// DLL uses __stdcall calling convention.
// DLL uses 4-byte struct member alignment. 


//************************************************************
// The following are function group markers. Use in Edit/Find
//  to locate function groupings.
//************************************************************

//*--- R E A D    A N D    W R I T E   D E V I C E --------------\
//*-- M E N U   A N D   C O N S O L E    H A N D L I N G --------\
//*---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N ----------------\
//*-- C O N F I G U R A T I O N    H A N D L I N G --------------\
//*-------- R  A  T  E    H A N D L I N G -----------------------\
//*--- R E A D    A N D    W R I T E   D E V I C E --------------\
//*-------- S   C   A   N   N   I   N   G -----------------------\
//*--- M I S C E L L A N E O U S   F U N C T I O N S ------------\




// IMPORTANT NOTE: Should attempt to trap user closing app using 
//   system menu.  Closing with console window system menu fails 
//   to stop any scanning in process. Improper exit also fails to 
//   free any memory that has been dynamically allocated.


//****************************************************************\
//================================================================*\
//==== MAIN FUNCTION ==============================================*>
//================================================================*/
/*****************************************************************/
int __cdecl main()
{
	GetWinVerInfo();
	
	hAppWindow = GetForegroundWindow();
	InitVars();


	memset(bScanTypes, SINGLE_CHAN, sizeof(bScanTypes));
	
	// IN-HOUSE TESTING ONLY MakeDialog();

	if(!SetupConsole()){
		MessageBox(0, "SetupConsole() failed.  EXITING APPLICATION", "-- error", MB_OK);
		return 1;}

	if(!ReadCfg()){
		MessageBox(hAppWindow, "ReadCfg() failed.  EXITING APPLICATION", "-- error", MB_OK);
		return 1;}

	if(!PrintMainMenuScreen()){
		MessageBox(hAppWindow, "PrintMainMenuScreen() failed.  EXITING APPLICATION", "-- error", MB_OK);
		return 1;}
	
	if(!LoadLibraries()){
		MessageBox(hAppWindow, "LoadLibraries() failed.  EXITING APPLICATION", "-- error", MB_OK);
		return 1;}

	if(!CheckLibFuncs()){
		MessageBox(hAppWindow, "CheckLibFuncs() failed.  EXITING APPLICATION", "-- error", MB_OK);
		return 1;}
	
	// IN-HOUSE TESTING ONLY TempFunc();

	UserInputMenu_MAIN();

	return 0;
}
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//-- M E N U   A N D   C O N S O L E    H A N D L I N G ---------







//***************************************************************







//***************************************************************
//*-- M E N U   A N D   C O N S O L E    H A N D L I N G --------\
//****************************************************************\
//================================================================*\
//==== USERINPUTMENU_MAIN FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN UserInputMenu_MAIN()
{
	char(cUserInputVal);

	SetWin32CursorOff();   		
	CLEAR_MSG_LINE 

	while((cUserInputVal != 'Q')
		&& (cUserInputVal != 'q'))
	{
		cUserInputVal = (char)getch();
		switch(cUserInputVal)
		{
			case 'Q': case 'q':
					CleanupBeforeExit();
					break;

			case 'I': case 'i':
					if(Initialize())
					{
						gotoxy(23,7);	sprintf(ConBuff, "                         "); WRITE_CON
						PrintMainMenuScreen();
					}

					if(fMsgPending) DispDLLMsg();

					break;

			case 'L': case 'l':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
						PrintDevicesAvailable();
					break;

			case 'F': case 'f':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
						UserInputMenu_FUNCTIONS();
					break;

			case 'U': case 'u':
					UserInputMenu_UTILITY();
					break;

			default :
					CLEAR_MSG_LINE 
					sprintf(ConBuff, "Invalid command"); WRITE_CON
					break;
		}
	}

	// for exit message when running in IDE
	CLEAR_MSG_LINE 

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== PRINTMAINMENUSCREEN FUNCTION ===============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintMainMenuScreen()
{
	clrscr();
	gotoxy(22,2); sprintf(ConBuff, "  MODEL 301 USB Data Acquisition System "); WRITE_CON
	gotoxy(22,4); sprintf(ConBuff, " -------------- MAIN MENU --------------"); WRITE_CON
	
	if(sDebugLevel){
		gotoxy(68,1);	sprintf(ConBuff, "Debug: %d", sDebugLevel); WRITE_CON }
	else{
		gotoxy(68,1);	sprintf(ConBuff, "          ", sDebugLevel); WRITE_CON }

	if(!fInitialized)
	{
		gotoxy(23,7);	sprintf(ConBuff, "I) Initialize Devices(s)"); WRITE_CON
		gotoxy(23,9);	sprintf(ConBuff, "Q) Quit Program"); WRITE_CON
		gotoxy(23,11);	sprintf(ConBuff, "U) Utility Menu"); WRITE_CON
		return TRUE;
	}
	else{
		gotoxy(23,7);	sprintf(ConBuff, "I) Re-Initialize Devices(s)"); WRITE_CON}

	gotoxy(23,9);	sprintf(ConBuff, "Q) Quit Program"); WRITE_CON
	gotoxy(23,11);	sprintf(ConBuff, "U) Utility Menu"); WRITE_CON
	gotoxy(23,13); sprintf(ConBuff, "L) List avalialable devices"); WRITE_CON
	gotoxy(23,15);	sprintf(ConBuff, "F) Functions Menu"); WRITE_CON

	if(fInitialized){ DispDLLMsg(); DisplayDigin(bLastDigin); }

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== USERINPUTMENU_FUNCTIONS FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN UserInputMenu_FUNCTIONS()
{
	PrintFunctionMenuScreen();
	char(cUserInputVal);

	SetWin32CursorOff();   		

	while((cUserInputVal != 'B') && (cUserInputVal != 'b'))
	{
		cUserInputVal = (char)getch();
		CLEAR_MSG_LINE 
		switch(cUserInputVal)
		{
			case 'Q': case 'q':
					CleanupBeforeExit();
					exit(0);
					break;

			case 'S': case 's':
					UserInputMenu_SCAN();
					break;

			case 'G': case 'g':
					GetOneConversion(usActiveDevID);
					if(fMsgPending) DispDLLMsg();
					break;

			case 'O': case 'o':
					DigitalOutput(usActiveDevID);
					if(fMsgPending) DispDLLMsg();
					break;

			case 'D': case 'd':
					CurDevIDChange();
					break;

			case 'C': case 'c':
					ChanChange(usActiveDevID, aM301ConfigData[bActiveDevAsIndex].bChan, USER_INPUT_REQUIRED);
					if(fMsgPending) DispDLLMsg();
					break;

			case 'M': case 'm':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);

					break;

			default :
					CLEAR_MSG_LINE 
					sprintf(ConBuff, "Invalid command"); WRITE_CON
					break;
		}
	}

	CLEAR_MSG_LINE PrintMainMenuScreen();

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== PRINTFUNCTIONMENUSCREEN FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintFunctionMenuScreen()
{
	clrscr();
	
	if(sDebugLevel){
		gotoxy(68,1);	sprintf(ConBuff, "Debug: %d", sDebugLevel); WRITE_CON}
	else{
		gotoxy(68,1);	sprintf(ConBuff, "          ", sDebugLevel); WRITE_CON}

	gotoxy(20,2);  sprintf(ConBuff,"  MODEL 301 USB Data Acquisition System "); WRITE_CON
	gotoxy(20,4);  sprintf(ConBuff," --------------FUNCTIONS MENU ---------"); WRITE_CON
	gotoxy(23,8);	sprintf(ConBuff,"Q) Quit Program"); WRITE_CON
	gotoxy(23,10);	sprintf(ConBuff,"B) Back to Main Menu"); WRITE_CON
	gotoxy(23,12);	sprintf(ConBuff,"S) Scan"); WRITE_CON
	gotoxy(23,14);	sprintf(ConBuff,"G) Get one conversion"); WRITE_CON
	gotoxy(23,16);	sprintf(ConBuff,"O) Digital Output"); WRITE_CON
	gotoxy(23,18);	sprintf(ConBuff,"D) Device ID"); WRITE_CON
	gotoxy(46,18);	
	sprintf(ConBuff, ": %u", usActiveDevID); WRITE_CON
	gotoxy(23,20);	sprintf(ConBuff,"C) Channel"); WRITE_CON
	gotoxy(46,20);	
	sprintf(ConBuff, ": %u", aM301ConfigData[bActiveDevAsIndex].bChan); WRITE_CON

	DispDLLMsg(); DisplayDigin(bLastDigin);

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== USERINPUTMENU_UTILITY FUNCTION =============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN UserInputMenu_UTILITY()
{
	PrintUtilityMenuScreen();
	char(cUserInputVal);

	SetWin32CursorOff();   		

	while((cUserInputVal != 'B') && (cUserInputVal != 'b'))
	{
		cUserInputVal = (char)getch();
		CLEAR_MSG_LINE 
		switch(cUserInputVal)
		{
			case 'Q': case 'q':
					CleanupBeforeExit();
					exit(0);
					break;


			case 'S': case 's':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
						SystemCalibration();

					break;


			case 'R': case 'r':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
					{
						ReInitializeDevice();  
						PrintUtilityMenuScreen();
					}

					break;


			case 'L': case 'l':
					// Initializes lists. Sorts app's list to match DLL's list.
					// If flag is set, DLL also displays all lists:
					//  DLL DevID, App DevID, DevStat, and Handle of app that
					//  owns particuliar device.
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
					{
						BYTE bTotDevCnt = 0;
						VerifyDevIDList(&bTotDevCnt, SHOW_LISTS);
						bNumDevices = bTotDevCnt;
					}

					break;


			case 'F': case 'f':
					FreeDeviceFromList();
					break;  


			case 'V': case 'v':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);
					else
						GetVersionInfo();
					break;  

			case 'M': case 'm':
					if(!fInitialized)
						MessageBox(hAppWindow, "\n\nThis function not available\n until initialized\n\n", "IMPORTANT NOTICE", MB_OK);

					break;

			default :
					CLEAR_MSG_LINE 
					sprintf(ConBuff, "Invalid command"); WRITE_CON
					break;
		}
	}

	CLEAR_MSG_LINE PrintMainMenuScreen();

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== PRINTUTILIYTMENUSCREEN FUNCTION ============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintUtilityMenuScreen()
{
	clrscr();

	if(sDebugLevel){
		gotoxy(68,1);	sprintf(ConBuff, "Debug: %d", sDebugLevel); WRITE_CON}
	else{
		gotoxy(68,1);	sprintf(ConBuff, "          ", sDebugLevel); WRITE_CON}

	gotoxy(20,2);  sprintf(ConBuff,"  MODEL 301 USB Data Acquisition System "); WRITE_CON
	gotoxy(20,4);  sprintf(ConBuff," ------------ UTILITIES MENU -----------"); WRITE_CON
	gotoxy(23,8);	sprintf(ConBuff,"Q) Quit Program"); WRITE_CON
	gotoxy(23,10);	sprintf(ConBuff,"B) Back to Main Menu"); WRITE_CON
	gotoxy(23,12);	sprintf(ConBuff,"S) System Calibration (need to be initialized)"); WRITE_CON
	gotoxy(23,14);	sprintf(ConBuff,"R) Reinit Device      (need to be initialized)"); WRITE_CON
	gotoxy(23,16);	sprintf(ConBuff,"L) Verify list        (need to be initialized)"); WRITE_CON
	gotoxy(23,18);	sprintf(ConBuff,"F) Free a Device From List"); WRITE_CON
	gotoxy(23,20);	sprintf(ConBuff,"L) Get Version        (need to be initialized)"); WRITE_CON

	if(fInitialized){ DispDLLMsg(); DisplayDigin(bLastDigin); 
		gotoxy(23,12);	sprintf(ConBuff,"S) System Calibration                         "); WRITE_CON
		gotoxy(23,14);	sprintf(ConBuff,"R) Reset Device                               "); WRITE_CON
		gotoxy(23,16);	sprintf(ConBuff,"L) Verify list                                "); WRITE_CON
		gotoxy(23,20);	sprintf(ConBuff,"V) Get Version                                "); WRITE_CON
	}

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== USERINPUTMENU_SCAN FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN UserInputMenu_SCAN()
{
	PrintScanMenuScreen();
	char(cUserInputVal);

	SetWin32CursorOff();   		

	while((cUserInputVal != 'B') && (cUserInputVal != 'b'))
	{
		cUserInputVal = (char)getch();
		CLEAR_MSG_LINE 
		switch(cUserInputVal)
		{
			case 'Q': case 'q':
					CleanupBeforeExit();
					exit(0);
					break;

			case 'C': case 'c':
					ConfigureScan();
					break;

			case 'S': case 's':
					StartScan(usActiveScanDevID);
					if(fMsgPending) DispDLLMsg();
					break;

			default :
					CLEAR_MSG_LINE 
					sprintf(ConBuff, "Invalid command"); WRITE_CON
					break;
		}
	}

	CLEAR_MSG_LINE PrintFunctionMenuScreen();

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== PRINTSCANMENUSCREEN FUNCTION ==============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintScanMenuScreen()
{
	clrscr();

	if(sDebugLevel){
		gotoxy(68,1);	sprintf(ConBuff, "Debug: %d", sDebugLevel); WRITE_CON }
	else{
		gotoxy(68,1);	sprintf(ConBuff, "          ", sDebugLevel); WRITE_CON }

	gotoxy(20,2); sprintf(ConBuff, "  MODEL 301 USB Data Acquisition System "); WRITE_CON
	gotoxy(20,4); sprintf(ConBuff, " ------------- SCAN MENU ---------------"); WRITE_CON

	bActiveDevAsIndex = 0;
	usActiveDevID = usLLABS_DeviceIDList[bActiveDevAsIndex];

	//8-29-02 gotoxy(60,5);	sprintf(ConBuff, "DevID:  %u", usActiveScanDevID); WRITE_CON
	//8-29-02 gotoxy(60,6);	sprintf(ConBuff, "Chan :  %d", aM301ConfigData[usActiveScanDevIndex].bChan); WRITE_CON
	//8-29-02 gotoxy(60,7);	sprintf(ConBuff, "Rate :  %4.2lf", aM301ConfigData[usActiveScanDevIndex].dblActualRate); WRITE_CON

	gotoxy(55,5);	sprintf(ConBuff, "DevID:       %u", usActiveScanDevID); WRITE_CON
	//8-29-02 gotoxy(55,6);	sprintf(ConBuff, "Chan      :  %d", aM301ConfigData[usActiveScanDevIndex].bChan); WRITE_CON
	//gotoxy(55,7);	sprintf(ConBuff, "Dev  Rate:   %4.2lf", aM301ConfigData[usActiveScanDevIndex].dblActualRate); WRITE_CON
	//gotoxy(60,7);	sprintf(ConBuff, "Scan Rate:   %4.2lf", aM301ConfigData[usActiveScanDevIndex].dblActualRate); WRITE_CON

	if(bScanTypes[usActiveScanDevIndex] == SINGLE_CHAN)
	{
		gotoxy(55,7);	sprintf(ConBuff, "Scan Rate:   %4.2lf", aM301ConfigData[usActiveScanDevIndex].dblActualRate); WRITE_CON
	}
	else
	{
		gotoxy(55,7);	sprintf(ConBuff, "Scan Rate:   %4.2lf", (aM301ConfigData[usActiveScanDevIndex].dblActualRate) / 10.0); WRITE_CON
	}


	if(bScanTypes[usActiveScanDevIndex] == SINGLE_CHAN)
	{ 
		gotoxy(55,6);	sprintf(ConBuff, "Chan:        %d", aM301ConfigData[usActiveScanDevIndex].bChan); WRITE_CON
		gotoxy(55,8);	sprintf(ConBuff, "Type:        1-Chan"); WRITE_CON 
	}
	else
	{ 
		gotoxy(55,6);	sprintf(ConBuff, "Chan:        0,1"); WRITE_CON
		gotoxy(55,8);	sprintf(ConBuff, "Type :       2-Chan"); WRITE_CON
	}


		//6-18-01 END OF NEW #############


	gotoxy(23,8);	sprintf(ConBuff, "Q) Quit Program"); WRITE_CON
	gotoxy(23,10);	sprintf(ConBuff, "B) Back to Functions Menu"); WRITE_CON
	gotoxy(23,12);	sprintf(ConBuff, "C) Configure scan"); WRITE_CON
	gotoxy(23,14);	sprintf(ConBuff, "S) Start scan"); WRITE_CON

	if(fInitialized){ DispDLLMsg(); DisplayDigin(bLastDigin); }

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SETWIN32CURSORON FUNCTION ==================================*>
//================================================================*/
/*****************************************************************/
void SetWin32CursorOn(void)
{
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}



//****************************************************************\
//================================================================*\
//==== SETWIN32CURSOROFF FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
void SetWin32CursorOff(void)
{
	ConsoleCursorInfo.bVisible = FALSE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}


//****************************************************************\
//================================================================*\
//==== CONSOLECTRLHANDLER FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOL ConsoleCtrlHandler(DWORD dwCtrlType)
{
	switch(dwCtrlType)
	{
		case CTRL_BREAK_EVENT:
		case CTRL_CLOSE_EVENT:
		case CTRL_LOGOFF_EVENT:
		case CTRL_SHUTDOWN_EVENT:
			CleanupBeforeExit();
		case CTRL_C_EVENT:
			break;
	}
	return true;
}

//****************************************************************\
//================================================================*\
//==== SETUPCONSOLE FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SetupConsole()
{
	char cBuff[128];
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);

	if(!hOutCon){
		MessageBox(hAppWindow, "Error writing to console", "-- error", MB_OK);
		return 1;}

	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon){
		MessageBox(hAppWindow, "Error reading from console", "-- error", MB_OK);
		return 1;}
	
	if(!SetConsoleCtrlHandler((PHANDLER_ROUTINE)ConsoleCtrlHandler, CTRL_BREAK_EVENT))
		MessageBox(hAppWindow, "Error setting up console close handler", "-- error", MB_OK);
	if(!SetConsoleCtrlHandler((PHANDLER_ROUTINE)ConsoleCtrlHandler, CTRL_CLOSE_EVENT))
		MessageBox(hAppWindow, "Error setting up console close handler", "-- error", MB_OK);
	if(!SetConsoleCtrlHandler((PHANDLER_ROUTINE)ConsoleCtrlHandler, CTRL_LOGOFF_EVENT))
		MessageBox(hAppWindow, "Error setting up console close handler", "-- error", MB_OK);
	if(!SetConsoleCtrlHandler((PHANDLER_ROUTINE)ConsoleCtrlHandler, CTRL_SHUTDOWN_EVENT))
		MessageBox(hAppWindow, "Error setting up console close handler", "-- error", MB_OK);


	ConsoleCursorInfo.dwSize = 1; ConsoleCursorInfo.bVisible = TRUE;

	sprintf(cBuff,"  IMPORTANT - IMPORTANT ->  Use  only    \"Q\"    to  exit  program.    "
		"                         Application Handle: %X", hAppWindow);
	SetConsoleTitle(cBuff); 

	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== DISPDLLMSG FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN DispDLLMsg()
{
	if(fMsgPending)
	{
		if(fMsgBuffFull)
		{
			gotoxy(0,1); sprintf(ConBuff, "               "); WRITE_CON gotoxy(0, 1); 
			sprintf(ConBuff, "Msg. Pending"); WRITE_CON
			gotoxy(0,2); sprintf(ConBuff, "               "); WRITE_CON gotoxy(0, 2); 
			sprintf(ConBuff, "Msg. Buff Overflow"); WRITE_CON
			gotoxy(0,3); sprintf(ConBuff, "               "); WRITE_CON gotoxy(0, 3); 
			sprintf(ConBuff, "M) Show Message"); WRITE_CON
			return TRUE;
		}

		gotoxy(0,1); sprintf(ConBuff, "               "); WRITE_CON gotoxy(0, 1); 
		sprintf(ConBuff, "Msg. Pending"); WRITE_CON
		gotoxy(0,2); sprintf(ConBuff, "               "); WRITE_CON gotoxy(0, 2); 
		sprintf(ConBuff, "M) Show Message"); WRITE_CON
		return TRUE;
	}

	return FALSE;
}



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N -----------------







//***************************************************************







//***************************************************************
//*---- I  N  I  T  I  A  L  I  Z  A  T  I  O  N ----------------\
//****************************************************************\
//================================================================*\
//==== INITVARS FUNCTION ==========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN InitVars()
{
	BYTE bCurIndex;
	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
	{
		apScanObject[bCurIndex] = NULL;
		usLLABS_DeviceIDList[bCurIndex] = 0;
		bDevScanning[bCurIndex] = 0;
	}

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== INITIALIZE FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN Initialize()
{
	BYTE bIndex = 0;
	USHORT ListTemp[64]; USHORT* pListTemp = ListTemp;

	if(fInitialized_ONCE)
	{
		for(bIndex = 0; bIndex < 64; bIndex++) ListTemp[bIndex] = pusLLABS_DeviceIDList[bIndex];
		// The following function sets to 0 any device that was successfully 
		//  removed from the list. That is the reason the original list is not used.
		pDLL_ReleaseDeviceFromIDList(pListTemp, FREE_ANY_DEV);
		
		fInitialized = FALSE;
	}

	BOOLEAN fDevFound = FALSE;
	BYTE bTotDevCnt = 0,	bCurIndex = 0;
	BYTE bSignOnRetryCnt = 0;

	pusLLABS_DeviceIDList = usLLABS_DeviceIDList;
	pbUnusedVar = bUnusedValues;

	for(bIndex = 0; bIndex < 64; bIndex++) ListTemp[bIndex] = 0;
	CLEAR_MSG_LINE sprintf(ConBuff, "Please wait ........."); WRITE_CON

	//'=======================================================================
	//'=== Initialize DLL, setting debug file option, and initialize    ======
	//'===  shared variables. With the first app that loads the DLL,    ======
	//'===  the DLL will also create a memory-mapped file and place     ======
	//'===  the device ID's of all the  devices that it is able to      ======
	//'===  locate. When the DLL's "DLL_InstanceInitDeviceList()" is    ======
	//'===  called, it will set the variable bNumDevicesShared equal    ======
	//'===  to the actual available devices that match those devices    ======
	//'===  that the calling application wishes to access.              ======
	//'=======================================================================
	if(!pDLL_Init(GetDesktopWindow(), hUnused, hUnused, sDebugLevel, &bNumDevices, pbUnusedVar, pusLLABS_DeviceIDList))
	{
		CLEAR_MSG_LINE sprintf(ConBuff, "Failed call to DLL_Init(...)"); WRITE_CON
		return FALSE;
	}


	CLEAR_MSG_LINE sprintf(ConBuff, "Succeeded call to DLL_Init(...)"); WRITE_CON

	if(!VerifyDevIDList(&bTotDevCnt, DONT_SHOW_LISTS)) return FALSE;

	bNumDevices = bTotDevCnt;

	BOOLEAN fDevFailedInit;  
	BYTE bFailedIndexCnt = 0;

	while(bCurIndex < bTotDevCnt)
	{
		fDevFailedInit = FALSE;
		bSignOnRetryCnt = 0;				
		
		//'=======================================================================
		//'=== Send signon token to each device ==================================
		//'=======================================================================
		DOUBLE dblRate_SAVE = aM301ConfigData[bCurIndex].dblRate;
		while(TRUE)
		{
			if(!SendSignon(usLLABS_DeviceIDList[bCurIndex]))
			{
				CLEAR_MSG_LINE sprintf(ConBuff, "Failed to signon device: %d. (any key to continue)", usLLABS_DeviceIDList[bCurIndex]); WRITE_CON
				getch();
				CLEAR_MSG_LINE sprintf(ConBuff, "Trying another device"); WRITE_CON
				fDevFailedInit = TRUE;
				break;
			}

			//'=======================================================================
			//'=== Send rate  to each device =========================================
			//'=======================================================================
			if(!SendRate(usLLABS_DeviceIDList[bCurIndex]))
			{
				CLEAR_MSG_LINE sprintf(ConBuff, "Resetting device: %d.   Please wait . . . .", usLLABS_DeviceIDList[bCurIndex]); WRITE_CON
				if(!pDLL_ResetDevice(usLLABS_DeviceIDList[bCurIndex], 0))
				{
					MessageBox(hAppWindow, "Error sending rate.\n\nCould not reset device.\n", "NOTICE----", 0);
					fDevFailedInit = TRUE;
					break;
				}

				bSignOnRetryCnt++;
				if(bSignOnRetryCnt > RETRY_MAX) { fDevFailedInit = TRUE; break; }

				continue;			
			}

			// Always quit this device if Reset fails
			if(fDevFailedInit) { aM301ConfigData[bCurIndex].dblRate = dblRate_SAVE; break; }

			// This call rarely fails. if it does, something is seriously wrong
			if(!SetRate(usLLABS_DeviceIDList[bCurIndex])) { bSignOnRetryCnt++; 	continue; }

			break;
		}

		if(fDevFailedInit) 
		{ 
			aM301ConfigData[bCurIndex].usDevID = 0; 
			ListTemp[bFailedIndexCnt] = usLLABS_DeviceIDList[bCurIndex]; 
			bFailedIndexCnt++; 
			usLLABS_DeviceIDList[bCurIndex] = 0; 
			bCurIndex++;	
			continue;
		}

		bCurIndex++; 

		// At least one device is now initialized
		fInitialized = TRUE; 
		fInitialized_ONCE = TRUE; 
		continue;
	}

	if(!fInitialized)
	{
	  MessageBox(hAppWindow, "\nNo devices initialized.\n"
				 "Some possible explanations:\n\n"
				 "\t No devices connected or poor cable connections\n"
				 "\t Another application is accessing requested device\n"
				 "\t An application accessing requested device terminateed with an error\n"
				 "\t    so DLL has device marked as still being used. If you think that is\n"
				 "\t    the case, then use the UTILITY menu screen to free the device from the\n"
				 "\t    DLL's list", "IMPORTANT NOTICE ---", MB_OK);
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "No devices initialized."); WRITE_CON

		// Need to free devices that may have been marked as "in use" above, and 
		//   re-initialize any vars that may have changed during attempted initialization
		pDLL_ReleaseDeviceFromIDList(pusLLABS_DeviceIDList, FREE_ONLY_APP_OWNED_DEVICES);
		InitVars();
		ReadCfg();
		return FALSE;
	}

	// If any device failed init, lists need to be sorted, and devices that failed can
	//   be removed from the list so they can be tried again by either this or another app.
	if(bFailedIndexCnt)
	{
		M301_CONFIG_DATA	M301ConfigData_TEMP[64]; PM301_CONFIG_DATA pM301ConfigData_TEMP = M301ConfigData_TEMP; memset(pM301ConfigData_TEMP, 0, sizeof(M301_CONFIG_DATA) * 64);
		pDLL_ReleaseDeviceFromIDList(pListTemp, FREE_ONLY_APP_OWNED_DEVICES);
		BYTE bValidDevIndex = 0;
		for(bIndex = 0; bIndex < 64; bIndex++) { if(usLLABS_DeviceIDList[bIndex]) { M301ConfigData_TEMP[bValidDevIndex].usDevID = aM301ConfigData[bIndex].usDevID; M301ConfigData_TEMP[bValidDevIndex].bChan = aM301ConfigData[bIndex].bChan; M301ConfigData_TEMP[bValidDevIndex].dblRate = aM301ConfigData[bIndex].dblRate; ListTemp[bValidDevIndex] = usLLABS_DeviceIDList[bIndex]; bValidDevIndex++; } }
		for(bIndex = 0; bIndex < 64; bIndex++) { aM301ConfigData[bIndex].usDevID = M301ConfigData_TEMP[bIndex].usDevID; aM301ConfigData[bIndex].bChan = M301ConfigData_TEMP[bIndex].bChan; aM301ConfigData[bIndex].dblRate = M301ConfigData_TEMP[bIndex].dblRate; usLLABS_DeviceIDList[bIndex] = ListTemp[bIndex]; }
	}

	// Setup some defaults
	bActiveDevAsIndex = 0;
	usActiveScanDevIndex	= bActiveDevAsIndex;
	usActiveDevID = usLLABS_DeviceIDList[bActiveDevAsIndex];
	usActiveScanDevID	= usActiveDevID;

	ChanChange(usActiveDevID, aM301ConfigData[bActiveDevAsIndex].bChan, NO_USER_INPUT_REQUIRED);

	CLEAR_MSG_LINE sprintf(ConBuff, "Done"); WRITE_CON

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== LOADLIBRARIES FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN LoadLibraries()
{
    if(fWin98Flag)
		hLibLL_USB = LoadLibrary ("LL_USB.DLL");
	else
		hLibLL_USB = LoadLibrary ("LL_USB2K.DLL");

    if(!hLibLL_USB) return FALSE;
    return TRUE;
}



//****************************************************************\
//================================================================*\
//==== CHECKLIBFUNCS FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN
CheckLibFuncs()
{  

//---------->
	pDLL_Init = (P_DLL_INIT)GetProcAddress(hLibLL_USB, "DLL_Init");
//---------->
	if(!pDLL_Init)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_Init(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_Init(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_Init(...)"); WRITE_CON
//---------->
	pDLL_GetDeviceIDList = (P_DLL_GET_DEVICE_ID_LIST)GetProcAddress(hLibLL_USB, "DLL_GetDeviceIDList");
//---------->
	if(!pDLL_GetDeviceIDList)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_GetDeviceIDList(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_GetDeviceIDList(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_GetDeviceIDList(...)"); WRITE_CON
//---------->
	pDLL_GetVersionInfo = (P_DLL_GET_VERSION_INFO)GetProcAddress(hLibLL_USB, "DLL_GetVersionInfo");
//---------->
	if(!pDLL_GetVersionInfo)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_GetVersionInfo(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_GetVersionInfo(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_GetVersionInfo(...)"); WRITE_CON
//---------->  
	pDLL_ResetDevice = (P_DLL_RESET_DEVICE)GetProcAddress(hLibLL_USB, "DLL_ResetDevice");
//---------->
	if(!pDLL_ResetDevice)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ResetDevice(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ResetDevice(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_ResetDevice(...)"); WRITE_CON
//---------->
	pDLL_InstanceInitDeviceList = (P_DLL_INSTANCE_INIT_DEVICE_LIST)GetProcAddress(hLibLL_USB, "DLL_InstanceInitDeviceList");
//---------->
	if(!pDLL_InstanceInitDeviceList)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_InstanceInitDeviceList(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_InstanceInitDeviceList(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_InstanceInitDeviceList(...)"); WRITE_CON
//---------->
	pDLL_ReleaseDeviceFromIDList = (P_DLL_RELEASE_DEVICE_FROM_IDLIST)GetProcAddress(hLibLL_USB, "DLL_ReleaseDeviceFromIDList");
//---------->
	if(!pDLL_ReleaseDeviceFromIDList)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReleaseDeviceFromIDList(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReleaseDeviceFromIDList(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_ReleaseDeviceFromIDList(...)"); WRITE_CON
//---------->
	pDLL_SetRate = (P_DLL_SET_RATE)GetProcAddress(hLibLL_USB, "DLL_SetRate");
//---------->
	if(!pDLL_SetRate)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_SetRate(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_SetRate(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE sprintf(ConBuff, "Found function DLL_SetRate(...)"); WRITE_CON
//---------->
	pDLL_ReadWriteOneDevice = (P_DLL_READ_WRITE_ONE_DEVICE)GetProcAddress(hLibLL_USB, "DLL_ReadWriteOneDevice");
//---------->
	if(!pDLL_ReadWriteOneDevice)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReadWriteOneDevice(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReadWriteOneDevice(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE 
    sprintf(ConBuff, "Found function DLL_ReadWriteOneDevice(...)"); WRITE_CON
//---------->
	pDLL_StartScan = (P_DLL_START_SCAN)GetProcAddress(hLibLL_USB, "DLL_StartScan_DIO");
//---------->
	if(!pDLL_StartScan)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_StartScan_DIO(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_StartScan_DIO(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE 
    sprintf(ConBuff, "Found function DLL_StartScan_DIO(...)"); WRITE_CON
//---------->
	pDLL_EndScan = (P_DLL_END_SCAN)GetProcAddress(hLibLL_USB, "DLL_EndScan_DIO");
//---------->
	if(!pDLL_EndScan)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_EndScan_DIO(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_EndScan_DIO(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE 
    sprintf(ConBuff, "Found function DLL_EndScan_DIO(...)"); WRITE_CON
//---------->
	pDLL_ReadScanData = (P_DLL_READ_SCAN_DATA)GetProcAddress(hLibLL_USB, "DLL_ReadScanData_DIO");
//---------->
	if(!pDLL_ReadScanData)
	{
		if(fWin98Flag)
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReadScanData_DIO(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		else
			MessageBox(hAppWindow, "failed to find function:\n     DLL_ReadScanData_DIO(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		return FALSE;
	}
	CLEAR_MSG_LINE 
    sprintf(ConBuff, "Found function DLL_ReadScanData_DIO(...)"); WRITE_CON

	return TRUE;
}
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------

 





//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//-- C O N F I G U R A T I O N    H A N D L I N G ---------------







//***************************************************************







//***************************************************************
//*-- C O N F I G U R A T I O N    H A N D L I N G --------------\
//****************************************************************\
//================================================================*\
//==== GETFILESTRING FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetFileString(char* szFileLineData)
{
    if(fgets(szFileLineData, 200, fpCfgIn) == NULL)
        return FALSE;

    return TRUE;
}



//****************************************************************\
//================================================================*\
//==== READCFG FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ReadCfg()
{
	UINT uiFormatTempVal = 0;
	DOUBLE dblFormatTempVal = 0;
	BYTE bCurIndex = 0;

	char szFileInfoBuff[1023];
	char szTempBuff[128];
	char szFileLineData[100];

	bNumDevices = 0;

	fValidConfigExists = FALSE;

	if((fpCfgIn = fopen("LL_USB.cfg", "r")) == NULL)
	  return FALSE;

	for(BYTE bArrayIndex = 0; bArrayIndex < 64; bArrayIndex++)
				usLLABS_DeviceIDList[bArrayIndex] = 0;

	// get header (note and date)
	if(!GetFileString(szFileLineData))
	  return FALSE;
  
	// get blank line
	if(!GetFileString(szFileLineData))
	  return FALSE;


	//4-25-01 START OF ADDED ##########
	// get model number 301 or 302) this code isn't implementing this 
	//  feature yet, but still needs to get it. See API documentation
	//  for more information on additional model 302 features
	if(!GetFileString(szFileLineData))
	  return FALSE;
  
	// get blank line
	if(!GetFileString(szFileLineData))
	  return FALSE;
	//4-25-01 END OF ADDED   ##########




  
	// get debug level        
	if(!GetFileString(szFileLineData))
	  return FALSE;

	sscanf(szFileLineData,"%d",&uiFormatTempVal); 
	sDebugLevel = (SHORT)uiFormatTempVal;

	if(sDebugLevel > 6)
	  sDebugLevel = 6;

	// get number of devices
	if(!GetFileString(szFileLineData))
	  return FALSE;

	sscanf(szFileLineData,"%d",&uiFormatTempVal);
	bNumDevicesTemp = (BYTE)uiFormatTempVal;

	pM301ConfigData = aM301ConfigData;

	for(bCurIndex = 0; bCurIndex < bNumDevices; bCurIndex++)
	{
	  aM301ConfigData[bCurIndex].usDevID = 0;
	  aM301ConfigData[bCurIndex].bChan = 0;
	  aM301ConfigData[bCurIndex].dblRate = 0;
	}

	sprintf(szFileInfoBuff, "\n");
	for(bCurIndex = 0; bCurIndex < bNumDevicesTemp; bCurIndex++)
	{
		// get blank line
		if(!GetFileString(szFileLineData))
		  return FALSE;
		// get misc line
		if(!GetFileString(szFileLineData))
		  return FALSE;
            
		sprintf(szTempBuff,  "Configuration for Device: %d\n", bCurIndex + 1);
		strcat(szFileInfoBuff, szTempBuff);
        
		// Get device ID
		if(!GetFileString(szFileLineData))
			return FALSE;

		sscanf(szFileLineData,"%u",&uiFormatTempVal);
		#ifndef IN_HOUSE
		{
			if((uiFormatTempVal < 101) || uiFormatTempVal > 32767)
				 MessageBox(Application->Handle, "There is an invalid Device ID entry in M301.cfg\n\n Device ID must be decimal value 101-32767. There must be no commas inserted\n\n Please correct the error and try again" , "FILE INFO -----", 0);
			fValidConfigExists = FALSE;
			return FALSE;
		}
		#endif
        
		sprintf(szTempBuff,  "Dev ID: \t%d\n", (USHORT)uiFormatTempVal);
		strcat(szFileInfoBuff, szTempBuff);
		usLLABS_DeviceIDList[bCurIndex] = (USHORT)uiFormatTempVal;
		pM301ConfigData[bCurIndex].usDevID = (USHORT)uiFormatTempVal;

        
		// Get current channel    
		if(!GetFileString(szFileLineData))
			return FALSE;

		sscanf(szFileLineData,"%d",&uiFormatTempVal); 
		pM301ConfigData[bCurIndex].bChan = (BYTE)uiFormatTempVal;
		sprintf(szTempBuff,  "Channel: \t%d\n", (BYTE)uiFormatTempVal);
		strcat(szFileInfoBuff, szTempBuff);
        
		// Get scanning rate    
		if(!GetFileString(szFileLineData))
			return FALSE;

		sscanf(szFileLineData,"\t%lf",&dblFormatTempVal); 
		pM301ConfigData[bCurIndex].dblRate = dblFormatTempVal;
		sprintf(szTempBuff,  "Rate: \t%lf\n", dblFormatTempVal);
		strcat(szFileInfoBuff, szTempBuff);
        
		sprintf(szTempBuff,  "\n");
		strcat(szFileInfoBuff, szTempBuff);
		bNumDevices++;
	}

	fValidConfigExists = TRUE;

	// For testing only
	//MessageBox(hAppWindow,szFileInfoBuff , "Configuration File Results --", 0);
	
	fclose(fpCfgIn);

	return TRUE;
}
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************







//-------- R  A  T  E      H  A  N  D  L  I  N  G ---------------







//***************************************************************
//*-------- R  A  T  E    H A N D L I N G -----------------------\
//****************************************************************\
//================================================================*\
//==== SETRATE FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SetRate(USHORT usDevID)
{
	BYTE bCurIndex;

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	if(!pDLL_SetRate(usDevID, aM301ConfigData[bCurIndex].dblRate))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed DLL_SetRate for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Succeeded call to DLL_SetRate(...)"); WRITE_CON
		
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SENDSIGNON FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SendSignon(USHORT usDevID)
{

	BYTE* pbHostClientDataBuf_READ = bHostClientDataBuf_READ;
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	clock_t ClockEnd;

	bHostClientDataBuf_WRITE[0] = CMND_SIGN_ON;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_SIGN_ON + NO_ARG;
	NumBytesToReadWrite = 8;

	BYTE bSignOnRetryCnt = 0;

	while(bSignOnRetryCnt < RETRY_MAX)
	{
		if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
				usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed to write to device. Resetting: %u (any key to continue)", usDevID); WRITE_CON
			getch();
			CLEAR_MSG_LINE sprintf(ConBuff, "Resetting device: %d.   Please wait . . . .", usDevID); WRITE_CON
			if(!pDLL_ResetDevice(usDevID, 0))
			{
				MessageBox(hAppWindow, "Could not reset device.\n", "NOTICE----", 0);
				return FALSE;
			}
			bSignOnRetryCnt++;
			continue;
		}

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Waiting settling time for SignOn/SysCal DevID: %d", usDevID); WRITE_CON

		// Need to wait settling time after a signon
		ClockEnd = clock() + (clock_t)3000;
		INT uiClockDiv = (ClockEnd - clock()) / 12;
		INT uiNewClockCnt = clock() + uiClockDiv;

		BYTE bDotCnt = 0;
		BYTE WaitMsgLgth = strlen("Waiting settling time for SignOn/SysCal DevID:     \0");

		while(clock() < ClockEnd)
		{
			// Print some dots to show activity
			if(clock() > uiNewClockCnt)
			{
				uiNewClockCnt = clock() + uiClockDiv;
				gotoxy(WaitMsgLgth + (bDotCnt * 2),24);
				sprintf(ConBuff, ".  "); WRITE_CON
				bDotCnt++;
			}
		}

		NumBytesToReadWrite = 32;

		if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
				usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed to write to device. Resetting: %u (any key to continue)", usDevID); WRITE_CON
			getch();
			CLEAR_MSG_LINE sprintf(ConBuff, "Resetting device: %d.   Please wait . . . .", usDevID); WRITE_CON
			if(!pDLL_ResetDevice(usDevID, 0))
			{
				MessageBox(hAppWindow, "Could not reset device.\n", "NOTICE----", 0);
				return FALSE;
			}
			bSignOnRetryCnt++;
			continue;
		}

		// Following for testing only
		//char szBuff[128], szBuff_TEMP[16];
		//sprintf(szBuff, "Bytes from calibration:  ");
		//for(BYTE bCurIndex = 1; bCurIndex < 7; bCurIndex++){sprintf(szBuff_TEMP, "%X  ", pbHostClientDataBuf_READ[bCurIndex]);	strcat(szBuff, szBuff_TEMP);}
		//strcat(szBuff, "   (any key to continue)"); CLEAR_MSG_LINE printf(szBuff); getch();	CLEAR_MSG_LINE


		// Device echoes <1,2,3,ModeRegs>
		// ModeRegs echoed for default signon rate of 100Hz
		BOOLEAN fSysCalSuccess = FALSE;
		if((pbHostClientDataBuf_READ[0] == 1)
			&& (pbHostClientDataBuf_READ[1] == 2) 
			&& (pbHostClientDataBuf_READ[2] == 3) 
			&& ((pbHostClientDataBuf_READ[3] & 0xfe) == 0x22) 
			&& (pbHostClientDataBuf_READ[4] == 0) 
			&& (pbHostClientDataBuf_READ[5] == 0x8c) 
			&& (pbHostClientDataBuf_READ[6] == 0))
			fSysCalSuccess = TRUE;

		if(!fSysCalSuccess)
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Incorrect bytes read. Trying again.", usDevID); WRITE_CON
			bSignOnRetryCnt++;
			continue;
		}
		break;
	}


	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SENDRATE FUNCTION ==========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SendRate(USHORT usDevID)
{
	clock_t ClockEnd;
	BYTE* pbHostClientDataBuf_READ = bHostClientDataBuf_READ;
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE bCurIndex;

	BYTE bLow, bMid, bHigh;
	if(!CalcRateCodes(&bLow, &bMid, &bHigh, usDevID))
		return FALSE;

	/* // For testing only
	CLEAR_MSG_LINE sprintf(ConBuff, "bLow: %u,   bMid: %u,    bHigh: %u", bLow, bMid, bHigh); WRITE_CON getch();
	*/

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	bHostClientDataBuf_WRITE[0] = CMND_SET_MODE;
	bHostClientDataBuf_WRITE[1] = bLow;
	bHostClientDataBuf_WRITE[2] = bMid;
	bHostClientDataBuf_WRITE[3] = bHigh;
	bHostClientDataBuf_WRITE[4] = 0x22;

	NumBytesToReadWrite = 8;

	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed Rate WRITE for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}
	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Waiting settling time for SysCal DevID: %d", usDevID); WRITE_CON

	// Need to wait settling time after syscal which is done during a rate change
	ClockEnd = clock() + (clock_t)3000;
	INT uiClockDiv = (ClockEnd - clock()) / 12;
	INT uiNewClockCnt = clock() + uiClockDiv;

	BYTE bDotCnt = 0;
	BYTE WaitMsgLgth = strlen("Waiting settling time for SysCal DevID:  /0");
	while(clock() < ClockEnd)
	{
		// Print some dots to show activity
		if(clock() > uiNewClockCnt)
		{
			uiNewClockCnt = clock() + uiClockDiv;
			gotoxy(WaitMsgLgth + (bDotCnt * 2),24);
			sprintf(ConBuff, ".  "); WRITE_CON
			bDotCnt++;
		}
	}

	NumBytesToReadWrite = 32;

	if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed READ of SysCal results for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();
		CLEAR_MSG_LINE 
		return FALSE;
	}

	// For testing only
	//char szBuff[128], szBuff_TEMP[16];
	//sprintf(szBuff, "Bytes from calibration:  ");
	//for(bCurIndex = 1; bCurIndex < 7; bCurIndex++){sprintf(szBuff_TEMP, "%X  ", pbHostClientDataBuf_READ[bCurIndex]);	strcat(szBuff, szBuff_TEMP);}
	//strcat(szBuff, "   (any key to continue)"); CLEAR_MSG_LINE printf(szBuff); getch();	CLEAR_MSG_LINE
		

	BOOLEAN fSysCalSuccess = FALSE;
	// Device echoes <1,2,3,ModeRegisters>

	if((pbHostClientDataBuf_READ[0] == 1)
		&& (pbHostClientDataBuf_READ[1] == 2) 
		&& (pbHostClientDataBuf_READ[2] == 3) 
		&& ((pbHostClientDataBuf_READ[3] & 0xfe) == 0x22) 
		&& (pbHostClientDataBuf_READ[4] == bHigh) 
		&& (pbHostClientDataBuf_READ[5] == bMid) 
		&& (pbHostClientDataBuf_READ[6] == bLow))
		fSysCalSuccess = TRUE;

	if(!fSysCalSuccess)
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed System Calibration for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	DisplayDigin(bLastDigin);

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Send Rate() successful"); WRITE_CON

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
	{
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) 
			break;
	}
 
	if(!pDLL_SetRate(usDevID, aM301ConfigData[bCurIndex].dblRate))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed DLL_SetRate for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();
		CLEAR_MSG_LINE 
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Succeeded call to DLL_SetRate(...)"); WRITE_CON

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== CALCRATECODES FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN CalcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID)
{
	BYTE bCurIndex;
	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	char buff[255];
	BYTE bArrayIndex = bCurIndex;
	BYTE bModeFlagBit = 128;
	DOUBLE dbRateTemp = aM301ConfigData[bCurIndex].dblRate;

	//constant for rate calculation. Is crystal frequency /512
	UINT lKVal = 9830400 / 512	;	
	BYTE bTypeMode = 16;
	double dbIntervalTemp = 1.0 / dbRateTemp;
	SHORT sRateCount = (SHORT)(lKVal * bTypeMode * dbIntervalTemp + 0.5);
	USHORT sRateCmndLow = sRateCount & 0xff;
	*bLow = (BYTE)sRateCmndLow;
	USHORT sRateCmdMid = bModeFlagBit | ((sRateCount & 0x1f00) / 256);
	*bMid = (BYTE)sRateCmdMid;
	*bHigh = 0;

	double dblActualInterval 
		= (double)(((sRateCmdMid & 0x1f) * 256) + sRateCmndLow) / (lKVal * bTypeMode);
	
	DOUBLE dblActualRate = 1.0 / dblActualInterval;

	if(dblActualRate != aM301ConfigData[bCurIndex].dblRate)
	{
		sprintf(buff, "The actual rate: %4.2lf is different from your requested rate: %4.2lf\n\n Do you want to proceed using the new calculated rate?", dblActualRate, aM301ConfigData[bCurIndex].dblRate); 
		
		if(MessageBox(hAppWindow, buff, "RATES", MB_YESNO | MB_ICONQUESTION) == IDNO)
		{
			return FALSE;
		}
	}

	aM301ConfigData[bCurIndex].dblActualRate = dblActualRate;

	return TRUE;
}
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************







//--- R E A D    A N D    W R I T E   D E V I C E ---------------







//***************************************************************
//*--- R E A D    A N D    W R I T E   D E V I C E --------------\
//****************************************************************\
//================================================================*\
//==== GETONECONVERSION FUNCTION ==================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetOneConversion(USHORT usDevID)
{
	// NOTE:  In this mode,  reading of device is slower than  scanning 
	//  mode. So occasionally a failure to get a conversion immediately 
	//  can occur. This sample code impliments a retry on failure.

	BYTE* pbHostClientDataBuf_READ = bHostClientDataBuf_READ;
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE bCurIndex;
	INT iRawCount;
	double dblVoltage;

	BYTE bRetryCnt = 0; 

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	bHostClientDataBuf_WRITE[0] = CMND_GET_CONVERSION;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_GET_CONVERSION + NO_ARG;

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "please wait . . . . . . ", usDevID); WRITE_CON

	NumBytesToReadWrite = 8;
	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed GetConv WRITE for DevID: %u (any key to continue)", usDevID); WRITE_CON
			getch();

			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
			getch();

			CLEAR_MSG_LINE 
			gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
			return FALSE;
	}


	clock_t ClockEnd;
	ClockEnd = clock() + (clock_t)200;
	while(clock() < ClockEnd);

	NumBytesToReadWrite = 32;

	if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed GetConv READ for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	if(pbHostClientDataBuf_READ[2] == 0xff)
	{
		MessageBox(hAppWindow, "Error reading conversion.\n\nResetting device.\n", "NOTICE----", MB_OK | MB_SYSTEMMODAL | MB_SETFOREGROUND);
		if(!SendResetCmnd(usDevID))
			return FALSE;
		else
			return TRUE;
	}
	if(pbHostClientDataBuf_READ[2] == 0x3)
	{
		MessageBox(hAppWindow, "Error reading conversion.\n\nMode registers reset by device.\n", "NOTICE----", MB_OK | MB_SYSTEMMODAL | MB_SETFOREGROUND);
		// wait time for device to reset
		clock_t ClockEnd;
		ClockEnd = clock() + (clock_t)2000;
		while(clock() < ClockEnd);

		NumBytesToReadWrite = 32;
		if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
				usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed read after device reset for DevID: %u (any key to continue)", usDevID); WRITE_CON
			getch();

			//6-8
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
			getch();

			CLEAR_MSG_LINE 
			gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
			return FALSE;
		}

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reset success for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return TRUE;
	}

	iRawCount = pbHostClientDataBuf_READ[4] 
		+ (pbHostClientDataBuf_READ[5] * 256) + (pbHostClientDataBuf_READ[6] * 65536);

	dblVoltage = (iRawCount - 8388608) * 0.00000059604645;
	CLEAR_MSG_LINE 

	/* // For testing purposes
	char szBuff[128];	char szBuff_TEMP[16];
	sprintf(szBuff, ""); for(bCurIndex = 4; bCurIndex < 7; bCurIndex++){
		sprintf(szBuff_TEMP, "%X  ", pbHostClientDataBuf_READ[bCurIndex]); strcat(szBuff, szBuff_TEMP);}
	sprintf(ConBuff, "Voltage: %2.6lf     Count: %u      Bytes: %s", dblVoltage, iRawCount, szBuff); WRITE_CON
	*/

	gotoxy(46,14);	
	sprintf(ConBuff, ": %  2.6lf", dblVoltage); WRITE_CON

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "done", usDevID); WRITE_CON

	DisplayDigin(bLastDigin);

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GETUSERINPUTFORCHANCHANGE FUNCTION =========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetUserInputForChanChange(BYTE* bChan)
{
	BYTE bChanTemp = 0;
	char cUserInputVal = 0;

	SetWin32CursorOn();

	BOOLEAN fDone = FALSE, fDoChanChange = FALSE;
	while(!fDone)
	{
		LINE_CLEAR(20)
		gotoxy(0,19); sprintf(ConBuff, "D) Done"); WRITE_CON
		gotoxy(0,20); sprintf(ConBuff, "Enter Channel (0, 1, 6, 7): "); WRITE_CON
		cUserInputVal = (char)getch();
		if((cUserInputVal == 'D') || (cUserInputVal == 'd')) break;

		if((cUserInputVal != '0') && (cUserInputVal != '1') && (cUserInputVal != '6') && (cUserInputVal != '7'))
		{
			gotoxy(0,20); sprintf(ConBuff, "Invalid channel.  (any key to continue)"); WRITE_CON
			getch(); LINE_CLEAR(20) continue;
		}
		switch(cUserInputVal)
		{
			case '0': bChanTemp = 0; break; case '1': bChanTemp = 1; break; 
			case '6': bChanTemp = 6; break; case '7': bChanTemp = 7; break; 
			default: bChanTemp = 0; break;
		}

		fDoChanChange = TRUE;
		LINE_CLEAR(20)
		gotoxy(0,20); sprintf(ConBuff, "Sending channel: %u", bChanTemp); WRITE_CON
		break;
	}

	SetWin32CursorOff();
	if(!fDoChanChange) return FALSE;

	*bChan = bChanTemp;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== CHANCHANGE FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ChanChange(USHORT usDevID, BYTE bChan, BOOLEAN fNeedUserInput)
{
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE bCurIndex;
	clock_t ClockEnd;

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	if(fNeedUserInput)
	{
		if(!GetUserInputForChanChange(&bChan))
		{
			LINE_CLEAR(19) LINE_CLEAR(20) LINE_CLEAR(21) LINE_CLEAR(22) LINE_CLEAR(23)
			return FALSE;
		}
	}

	bHostClientDataBuf_WRITE[0] = CMND_CHAN_CHG;
	bHostClientDataBuf_WRITE[1] = bChan;
	bHostClientDataBuf_WRITE[2] = CMND_CHAN_CHG + bChan;

	NumBytesToReadWrite = 8;

	ClockEnd = clock() + (clock_t)20;
	while(clock() < ClockEnd);

	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed ChanChange WRITE for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	if(fNeedUserInput)
	{
		LINE_CLEAR(19) LINE_CLEAR(20) LINE_CLEAR(21) LINE_CLEAR(22) LINE_CLEAR(23)
	}

	aM301ConfigData[bActiveDevAsIndex].bChan = bChan;

	gotoxy(23,20);	sprintf(ConBuff,"C) Channel"); WRITE_CON
	gotoxy(46,20);	
	sprintf(ConBuff, ":  %u", aM301ConfigData[bActiveDevAsIndex].bChan); WRITE_CON
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GETUSERINPUTFORCHANCHANGE FUNCTION =========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetUserInputForDigOut(BYTE* bDigOutVal)
{
	UINT uiDigOutTemp = 0;
	BYTE bDigOutTemp = 0;
	char cUserInputVal = 0;
	char caUserInputValString[32];

	BOOLEAN fDone = FALSE, fDoDigOut = FALSE;

	SetWin32CursorOn();

	while(!fDone)
	{
		LINE_CLEAR(22)
		gotoxy(0,23); sprintf(ConBuff, "D) Done"); WRITE_CON
		gotoxy(0,22); sprintf(ConBuff, "Enter value (0 - 255): "); WRITE_CON
		FlushConsoleInputBuffer(hInCon);
		gets(caUserInputValString);
		if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd')) break;
		uiDigOutTemp = (UINT)atoi(caUserInputValString);
		if(uiDigOutTemp > 255)
		{
			gotoxy(0,22); sprintf(ConBuff, "Invalid DigOut value: %s.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			LINE_CLEAR(22)
			continue;
		}
		bDigOutTemp = (BYTE)uiDigOutTemp; 
		fDoDigOut = TRUE;
		gotoxy(0,22); sprintf(ConBuff, "Sending DigOut: %u", bDigOutTemp); WRITE_CON
		break;
	}

	LINE_CLEAR(22)	LINE_CLEAR(23)

	SetWin32CursorOff();

	if(!fDoDigOut) return FALSE;

	*bDigOutVal = bDigOutTemp;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== DIGITALOUTPUT FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN DigitalOutput(USHORT usDevID)
{
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE bCurIndex;
	clock_t ClockEnd;

	BYTE bDigOutVal;

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) break;

	if(!GetUserInputForDigOut(&bDigOutVal))
		return FALSE;

	bHostClientDataBuf_WRITE[0] = CMND_DIG_OUT;
	bHostClientDataBuf_WRITE[1] = bDigOutVal;
	bHostClientDataBuf_WRITE[2] = CMND_DIG_OUT + bDigOutVal;

	NumBytesToReadWrite = 8;

	ClockEnd = clock() + (clock_t)20;
	while(clock() < ClockEnd);

	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed DigitalOutput WRITE for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "DigOut %d sent for DevID: %u.", bDigOutVal, usDevID); WRITE_CON
	gotoxy(46,18);	
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== CURDEVIDCHANGE FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN CurDevIDChange()
{
	USHORT usDigOutTemp = 0;
	char cUserInputVal = 0;
	char caUserInputValString[32];

	BOOLEAN fDone = FALSE, fDevIDFoundInList = FALSE;

	SetWin32CursorOn();

	while(!fDone)
	{
		LINE_CLEAR(22)
		gotoxy(0,23); sprintf(ConBuff, "D) Done"); WRITE_CON
		gotoxy(0,22); sprintf(ConBuff, "Enter value (0 - 32767): "); WRITE_CON
		FlushConsoleInputBuffer(hInCon);
		gets(caUserInputValString);
		if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd')) break;
		usDigOutTemp = (USHORT)atoi(caUserInputValString);
		if((usDigOutTemp > 32767) || (usDigOutTemp == 0))
		{
			gotoxy(0,22); sprintf(ConBuff, "Invalid DevID value: %s.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			LINE_CLEAR(22)
			continue;
		}
		for(BYTE bIndex = 0; bIndex < 64; bIndex++)
		{
			if(pusLLABS_DeviceIDList[bIndex] == usDigOutTemp) 
			{
				fDevIDFoundInList = TRUE;
				break;
			}
		}
		if(!fDevIDFoundInList)
		{
			gotoxy(0,22); sprintf(ConBuff, "DevID  %s  not found in list.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			LINE_CLEAR(22)
			continue;
		}
		
		usActiveDevID = usDigOutTemp;
		gotoxy(46,18);	
		sprintf(ConBuff, ": %u          ", usActiveDevID); WRITE_CON
		break;
	}


	LINE_CLEAR(22)	LINE_CLEAR(23)

	SetWin32CursorOff();

	if(!fDevIDFoundInList) return FALSE;

	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== SENDRESETCMND FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SendResetCmnd(USHORT usDevID)
{
	BYTE* pbHostClientDataBuf_READ = bHostClientDataBuf_READ;
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE bCurIndex;
	BOOLEAN fValidDev = FALSE;

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		if(usLLABS_DeviceIDList[bCurIndex] == usDevID) 
		{
			fValidDev = TRUE;
			break;
		}
	if(!fValidDev)
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Invalid DevID(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
	}

	bHostClientDataBuf_WRITE[0] = CMND_RESET;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_RESET + NO_ARG;

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "please wait ....", usDevID); WRITE_CON

	NumBytesToReadWrite = 8;
	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed sending CMND_RESET for DevID: %u (any key to continue)", usDevID); WRITE_CON
			getch();

			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
			getch();

			CLEAR_MSG_LINE 
			gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
			return FALSE;
	}

	// wait time for device to reset
	clock_t ClockEnd;
	ClockEnd = clock() + (clock_t)2000;
	while(clock() < ClockEnd);

	NumBytesToReadWrite = 32;
	if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed read after CMND_RESET for DevID: %u (any key to continue)", usDevID); WRITE_CON
		getch();

		//6-8
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Device reset success(any key to continue)"); WRITE_CON
	getch();

	CLEAR_MSG_LINE 
	gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 

	ChanChange(usDevID, aM301ConfigData[bCurIndex].bChan, NO_USER_INPUT_REQUIRED);
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== RESETDEVICE FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ReInitializeDevice()
{
	char cUserInputVal = 0, caUserInputValString[32];
	USHORT usActiveDevID_TEMP = usActiveDevID;
	BYTE bDevListIndex = bActiveDevAsIndex;
	BOOLEAN fDone = FALSE, fDevFound = FALSE;
	
	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Device: %u  (Y)es  (N)o? ", usActiveDevID); WRITE_CON
		
	while((cUserInputVal != 'Y') && (cUserInputVal != 'y') && (cUserInputVal != 'N') && (cUserInputVal != 'n'))
	{
		cUserInputVal = (char)getch();
	}

	if((cUserInputVal == 'N') || (cUserInputVal == 'n'))
	{
		while(!fDone)
		{
			LINE_CLEAR(20)
			gotoxy(0,19); sprintf(ConBuff, "D) Done"); WRITE_CON
			gotoxy(0,20); sprintf(ConBuff, "Enter DevID: "); WRITE_CON
			cUserInputVal = (char)getch();
			if((cUserInputVal == 'D') || (cUserInputVal == 'd'))
			{
				fDone = TRUE;
				break;
			}

			FlushConsoleInputBuffer(hInCon);
			gets(caUserInputValString);
			if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd'))
			{
				fDone = TRUE;
				break;
			}

			usActiveDevID_TEMP = (USHORT)atoi(caUserInputValString);
			if(usActiveDevID_TEMP == 0)
			{
				gotoxy(0,20); sprintf(ConBuff, "Invalid DevID: %s.  (any key to continue)", caUserInputValString); WRITE_CON
				getch();
				continue;
			}

			fDevFound = FALSE;
			for(BYTE bCurDevIndex = 0; bCurDevIndex < 64; bCurDevIndex++)
			{
				if(usLLABS_DeviceIDList[bCurDevIndex] == usActiveDevID_TEMP)
				{
					fDevFound = TRUE;
					bDevListIndex = bCurDevIndex;
					break;
				}
			}
			if(!fDevFound)
			{
				gotoxy(0,20); sprintf(ConBuff, "DevID: %s Not found in list.  (any key to continue)", caUserInputValString); WRITE_CON
				getch();
				usActiveDevID_TEMP = usActiveDevID;
				continue;
			}
		}
	}
	
	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Please wait (approx 4 seconds) . . . . ."); WRITE_CON

	BYTE bSignOnRetryCnt = 0;
	BOOLEAN fDevFailedInit = FALSE;  
			
	while(TRUE)
	{
		if(!SendSignon(usActiveDevID_TEMP))
		{
			CLEAR_MSG_LINE sprintf(ConBuff, "Failed to signon device: %d. (any key to continue)", usActiveDevID_TEMP); WRITE_CON
			getch();
			CLEAR_MSG_LINE sprintf(ConBuff, "Trying another device"); WRITE_CON
			fDevFailedInit = TRUE;
			break;
		}

		//'=======================================================================
		//'=== Send rate to device ===============================================
		//'=======================================================================
		if(!SendRate(usActiveDevID_TEMP))
		{
			CLEAR_MSG_LINE sprintf(ConBuff, "Resetting device: %d.   Please wait . . . .", usActiveDevID_TEMP); WRITE_CON
			if(!pDLL_ResetDevice(usActiveDevID_TEMP, 0))
			{
				MessageBox(hAppWindow, "Error sending rate.\n\nCould not reset device.\n", "NOTICE----", 0);
				fDevFailedInit = TRUE;
				break;
			}

			bSignOnRetryCnt++;
			if(bSignOnRetryCnt > RETRY_MAX) { fDevFailedInit = TRUE; break; }

			continue;			
		}

		// This call rarely fails. if it does, something is seriously wrong
		if(!SetRate(usActiveDevID_TEMP)) { bSignOnRetryCnt++; 	continue; }
		break;
	}

	if(fDevFailedInit)
	{
		MessageBox(hAppWindow, "\nDevice failed to reinitialized.\n"
				 "Some possible explanations:\n\n"
				 "\t Device not connected or poor cable connections\n"
				 "\t Another application is accessing requested device\n"
				 "\t An application accessing requested device terminateed with an error\n"
				 "\t    so DLL has device marked as still being used. If you think that is\n"
				 "\t    the case, then use the UTILITY menu screen to free the device from the\n"
				 "\t    DLL's list", "IMPORTANT NOTICE ---", MB_OK);
		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "Device failed to reinitialize"); WRITE_CON
		return FALSE;
	}

	ChanChange(usActiveDevID_TEMP, aM301ConfigData[bDevListIndex].bChan, NO_USER_INPUT_REQUIRED);

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Reinitialize Success for DevID: %u. (any key to continue)", usActiveDevID_TEMP); WRITE_CON
	getch();
	gotoxy(46,18);	
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SYSTEMCALIBRATION FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN SystemCalibration()
{
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	BYTE* pbHostClientDataBuf_READ = bHostClientDataBuf_READ;
	clock_t ClockEnd;

	bHostClientDataBuf_WRITE[0] = CMND_SYS_CAL;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_SYS_CAL + NO_ARG;

	NumBytesToReadWrite = 8;

	ClockEnd = clock() + (clock_t)20;
	while(clock() < ClockEnd);

	if(!pDLL_ReadWriteOneDevice(DO_WRITE, pbHostClientDataBuf_WRITE, 
			usActiveDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed SysCal WRITE for DevID: %u (any key to continue)", usActiveDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	// Need to wait settling time after a syscal
	ClockEnd = clock() + (clock_t)2000;
	INT uiClockDiv = (ClockEnd - clock()) / 12;
	INT uiNewClockCnt = clock() + uiClockDiv;

	BYTE bDotCnt = 0;
	BYTE WaitMsgLgth = strlen("Waiting settling time for SysCal DevID:     \0");
	CLEAR_MSG_LINE 
	sprintf(ConBuff,			  "Waiting settling time for SysCal DevID: %d", usActiveDevID); WRITE_CON

	while(clock() < ClockEnd)
	{
		// Print some dots to show activity
		if(clock() > uiNewClockCnt)
		{
			uiNewClockCnt = clock() + uiClockDiv;
			gotoxy(WaitMsgLgth + (bDotCnt * 2),24);
			sprintf(ConBuff, ".  "); WRITE_CON
			bDotCnt++;
		}
	}

	NumBytesToReadWrite = 32;

	if(!pDLL_ReadWriteOneDevice(DO_READ, pbHostClientDataBuf_READ, 
			usActiveDevID, &NumBytesToReadWrite, &bLastDigin, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed Read after SysCal for DevID: %u (any key to continue)", usActiveDevID); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Device reinitialization required(any key to continue)"); WRITE_CON
		getch();

		CLEAR_MSG_LINE 
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		
		return FALSE;
	}

	// A successful calibration returns the following byte sequence.
	BOOLEAN fSysCalSuccess = FALSE;
	if((pbHostClientDataBuf_READ[0] == 1)
		&& (pbHostClientDataBuf_READ[1] == 2) 
		&& (pbHostClientDataBuf_READ[2] == 3))
		fSysCalSuccess = TRUE;

	if(!fSysCalSuccess)
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed System Calibration for DevID: %u (any key to continue)", usActiveDevID); WRITE_CON
		getch();
		gotoxy(0,24); sprintf(ConBuff, "                                                                 "); WRITE_CON gotoxy(0,24); 
		return FALSE;
	}

	DisplayDigin(bLastDigin);

	if(!ChanChange(usActiveDevID, aM301ConfigData[bActiveDevAsIndex].bChan, NO_USER_INPUT_REQUIRED))
		return FALSE;
	
	CLEAR_MSG_LINE 
	sprintf(ConBuff, "SysCal Success for DevID: %u.", usActiveDevID); WRITE_CON
	gotoxy(46,18);	
	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== VERIFYDEVIDLIST FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN VerifyDevIDList(BYTE* bTotDevCnt, BOOLEAN fShowLists)
{
	BYTE bCurIndex = 0;
	pusLLABS_DeviceIDList = usLLABS_DeviceIDList;

	//'=======================================================================
	//'=== Check actual installed devices against the ones listed       ======
	//'===  by the application, from a config file for example. When    ======
	//'===  this function returns, sLLABS_DeviceIDList() will contain   ======
	//'===  a listing of the available devices as found by the DLL.     ======
	//'===  For example, if the following is true before the call:      ======
	//'===  sLLABS_DeviceIDList(0) = 33                                 ======
	//'===  sLLABS_DeviceIDList(1) = 85                                 ======
	//'===  sLLABS_DeviceIDList(3) = 12                                 ======
	//'===  sLLABS_DeviceIDList(4) = 129                                ======
	//'===  sLLABS_DeviceIDList(5) = 65                                 ======
	//'===  and only device ID #85 and #65 exists, then afterwards      ======
	//'===  the array will look like:                                   ======
	//'===  sLLABS_DeviceIDList(0) = 0                                  ======
	//'===  sLLABS_DeviceIDList(1) = 85                                 ======
	//'===  sLLABS_DeviceIDList(3) = 0                                  ======
	//'===  sLLABS_DeviceIDList(4) = 0                                  ======
	//'===  sLLABS_DeviceIDList(5) = 65                                 ======
	//'===  The bNumDevices variable (passed in DLL_Init() above will   ======
	//'===   will equal the number devices found by the DLL that match  ======
	//'===   the ID's of devies requested by the app.  The variable     ======
	//'===   bNumDevices will equal the number of devices found by the  ======
	//'===   DLL that equal the requested devices. In this case that    ======
	//'===   would be "2". Take precaution to preserve a copy of the    ======
	//'===   bNumDevices and/or sLLABS_DeviceIDList if you need to know ======
	//'===   what their values were before making this call.            ======
	//'=======================================================================

	USHORT usLLABS_DeviceIDList_TEMP			[64];
	M301_CONFIG_DATA aM301ConfigData_TEMP	[64];	

	if(fInitialized)
	{
		// Save copy of current list. If initialized, the current list has DevID's
		//  that were already confirmed as valid.
		for(bCurIndex = 0; bCurIndex < 64; bCurIndex++) 
			usLLABS_DeviceIDList_TEMP[bCurIndex] = usLLABS_DeviceIDList[bCurIndex];
	}
	else
		memset(usLLABS_DeviceIDList_TEMP, 0, 64);


	if(!pDLL_InstanceInitDeviceList(fShowLists))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed call to DLL_InstanceInitDeviceList(...)"); WRITE_CON
		return FALSE;
	}

	if(fInitialized)
	{
		// See if any of the DevID's in our list weren't valid.
		USHORT usListTemp[64]; memset(usListTemp, 0, 64);
		BYTE bNotFoundListIndex = 0; BOOLEAN fDevFound = FALSE;
		for(BYTE bCurIndex_OUTER = 0; bCurIndex_OUTER < 64; bCurIndex_OUTER++)
		{
			fDevFound = FALSE;
			for(BYTE bCurIndex_INNER = 0; bCurIndex_INNER < 64; bCurIndex_INNER++)
			{
				if(usLLABS_DeviceIDList_TEMP[bCurIndex_OUTER] = usLLABS_DeviceIDList[bCurIndex_INNER])
				fDevFound = TRUE;
				break;
			}
			if(!fDevFound)
			{
				usListTemp[bNotFoundListIndex] = usLLABS_DeviceIDList_TEMP[bCurIndex_OUTER];
				bNotFoundListIndex++;
			}
		}

		// One of the DevID's that was in the list is no longer in list, so let it be known.
		if(usListTemp[0])
		{
			BYTE bIndex = 0; char LocalBuff[32];
			sprintf(ConBuff, "The following DevID's weren't found by DLL: ");
			while(usListTemp[bIndex])
			{
				sprintf(LocalBuff, "%d ", usListTemp); bIndex++; strcat(ConBuff, LocalBuff);
			}
			WRITE_CON
			strcat(ConBuff, "(any key to continue)");
			getch();
		}
	}

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++) usLLABS_DeviceIDList_TEMP[bCurIndex] = 0;

	BYTE bTotDevCnt_TEMP = 0;

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
	{
		if(usLLABS_DeviceIDList[bCurIndex])
		{    
			// Sort list, removing only valid Device ID's are listed
			usLLABS_DeviceIDList_TEMP[bTotDevCnt_TEMP] = usLLABS_DeviceIDList[bCurIndex];
			aM301ConfigData_TEMP[bTotDevCnt_TEMP] = aM301ConfigData[bCurIndex];	
			bTotDevCnt_TEMP++;
		}
	}

	*bTotDevCnt = bTotDevCnt_TEMP;

	if(bTotDevCnt_TEMP)
	{
		for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		{
			usLLABS_DeviceIDList[bCurIndex] = usLLABS_DeviceIDList_TEMP[bCurIndex];
			aM301ConfigData[bCurIndex] = aM301ConfigData_TEMP[bCurIndex] ;			
		}

		bActiveDevAsIndex	= 0;
		usActiveDevID		= usLLABS_DeviceIDList[0];
		fNeedToFreeListOnExit = TRUE;
	}
	else
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "No valid DevID's                              "); WRITE_CON
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "List verified."); WRITE_CON
	gotoxy(46,18);	
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GETVERSIONINFO FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetVersionInfo(void)
{
	USHORT usVersion = 0;
	char cDLLVersion[32], cDrvrVersion[32]; 
	char* cpDLLVersion = cDLLVersion;
	char* cpDrvrVersion = cDrvrVersion;

	if(!pDLL_GetVersionInfo(usActiveDevID, fDO_DISP_VER, &usVersion, cpDLLVersion, cpDrvrVersion))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed DLL_GetVersionInfo()"); WRITE_CON
		gotoxy(46,18); return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Version read successfully."); WRITE_CON
	gotoxy(46,18); return TRUE;
}



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------







//***************************************************************







//-------- S   C   A   N   N   I   N   G ------------------------






//***************************************************************
//*-------- S   C   A   N   N   I   N   G -----------------------\
//****************************************************************\
//================================================================*\
//==== ALLOCSCANMEM FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN AllocScanMem(USHORT usDevID)
{
	BYTE bDevIndex;
	for(bDevIndex = 0; bDevIndex < 64; bDevIndex++)
		if(usLLABS_DeviceIDList[bDevIndex] == usDevID) break;

	if(apScanObject[bDevIndex] == NULL)
	{
		apScanObject[bDevIndex] = new SCAN_OBJECT;
		if(!apScanObject[bDevIndex])
		{
			MessageBox(hAppWindow, "\nMemory allocation error", "ERROR ----", MB_OK);
			return FALSE;
		}
	}

	apScanObject[bDevIndex]->SO_uiStatus = 0;
	//6-18-01apScanObject[bDevIndex]->SO_bScanType = SINGLE_CHAN;

	//6-18-01
	apScanObject[bDevIndex]->SO_bScanType = bScanTypes[bDevIndex];

	//6-18-01 valid values below are 0 or 2
	// In single channel scan, this value is completely ignored.
	// In two channel mode, if it's 0 then it defaults to 2. Any
	//  other value can cause errors except when using newer scan
	//  types with appropriate chans for each.

	//8-29=02apScanObject[bDevIndex]->SO_bScanArg = 0;
	if(bScanTypes[bDevIndex] == SINGLE_CHAN)
		apScanObject[bDevIndex]->SO_bScanArg = 0;
	else
		apScanObject[bDevIndex]->SO_bScanArg = 2;



	apScanObject[bDevIndex]->SO_dblRate = aM301ConfigData[bDevIndex].dblRate;
	apScanObject[bDevIndex]->SO_uiTotalPointsReadByDrvr = 0;

	// make the following whatever size you want. But when calling 
	//  DLL_ReadScanData(...) never make "usNumScansToRead" larger
	//  than this size.  The DLL maintains a  32768 byte  circular 
	//  buffer. When a call is made to read scan data, the DLL 
	//  returns the number of bytes requested and advances it's
	//  buffer tail pointer.
	apScanObject[bDevIndex]->SO_uiSizeVoltageArray = 1000; 

	apScanObject[bDevIndex]->SO_uiCurHead = 0;
	apScanObject[bDevIndex]->SO_uiCurTail = 0;
	apScanObject[bDevIndex]->SO_bChecksum = 0;
	apScanObject[bDevIndex]->SO_DeviceDisconnect = 0;
	apScanObject[bDevIndex]->SO_ScanStartTime = clock();


	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== CONFIGURESCAN FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ConfigureScan()
{
	BYTE bCurDevIndex;
	char cUserInputVal = 0, caUserInputValString[32];
	USHORT usDevID;
	DOUBLE dblRateTemp;
	BYTE bScanTypeTemp;

	BOOLEAN fDone = FALSE, fDoChan = FALSE, fDoRate = FALSE, fDevFound = FALSE;

	SetWin32CursorOn();

	//6-19-01
   char KeyEntryBuff[32];
	int iKeyIndex, ch;   
	BOOLEAN fDoneInput = FALSE;


	while(!fDone)
	{
		LINE_CLEAR(20)
		gotoxy(0,19); sprintf(ConBuff, "D) Done"); WRITE_CON
		FlushConsoleInputBuffer(hInCon);
		gotoxy(0,20); sprintf(ConBuff, "Enter DevID: "); WRITE_CON

		/* //6-19-01
		cUserInputVal = (char)getch();
		if((cUserInputVal == 'D') || (cUserInputVal == 'd'))
		{
			fDone = TRUE;
			break;
		}
		//FlushConsoleInputBuffer(hInCon);

		gets(caUserInputValString);
		if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd'))
		{
			fDone = TRUE;
			break;
		}

		usDevID = (USHORT)atoi(caUserInputValString);
		*/ //6-19-01

		//########################################
		//6-19-01 START OF ADDED #################
		iKeyIndex = 0;
		for(; (iKeyIndex < 80) && ((ch = getchar()) != EOF) && (ch != '\n' ) && (ch != 'd' ) && (ch != 'D' ); iKeyIndex++ )      
			
		KeyEntryBuff[iKeyIndex] = (char)ch; KeyEntryBuff[iKeyIndex] = '\0';
		for(BYTE bcIndex = 0; bcIndex < iKeyIndex; bcIndex++)
		{
			if((KeyEntryBuff[bcIndex] == 'D')  || (KeyEntryBuff[bcIndex] == 'd'))
			{ fDoneInput = TRUE; break; }
		}
		if(fDoneInput) break;
		usDevID = (USHORT)atoi(KeyEntryBuff);
		//6-19-01 END OF ADDED   #################
		//########################################


		if(usDevID == 0)
		{
			gotoxy(0,20); sprintf(ConBuff, "Invalid DevID: %s.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			continue;
		}

		fDevFound = FALSE;
		for(bCurDevIndex = 0; bCurDevIndex < 64; bCurDevIndex++)
		{
			if(usLLABS_DeviceIDList[bCurDevIndex] == usDevID)
			{
				fDevFound = TRUE;
				usActiveScanDevIndex = bCurDevIndex;
				usActiveScanDevID = usDevID;
				break;
			}
		}
		if(!fDevFound)
		{
			gotoxy(0,20); sprintf(ConBuff, "DevID: %s Not found in list.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			continue;
		}
		
		if(apScanObject[usActiveScanDevIndex])
		{
			delete [] apScanObject[usActiveScanDevIndex];
			apScanObject[usActiveScanDevIndex] = NULL;
		}
		
		if(!AllocScanMem(usDevID))
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed call to AllocScanMem(). Unable to scan."); WRITE_CON
			SetWin32CursorOff();
			return FALSE;
		}

		while(!fDone)
		{
			LINE_CLEAR(20)
			gotoxy(0,20); sprintf(ConBuff, "Log Scans to file? (Y)es (N)o: "); WRITE_CON
			cUserInputVal = (char)getch();
			if((cUserInputVal == 'D') || (cUserInputVal == 'd'))
			{
				fDone = TRUE;
				break;
			}

			if(((char)cUserInputVal == 'Y') || ((char)cUserInputVal == 'y'))
			{
				fLogScansToFile = TRUE;
				break;
			}

			if(((char)cUserInputVal == 'N') || ((char)cUserInputVal == 'n'))
			{
				fLogScansToFile = FALSE;
				break;
			}

			gotoxy(0,20); sprintf(ConBuff, "Invalid Type entry  (any key to continue)"); WRITE_CON
			getch();
			continue;
		}

		while(!fDone)
		{
			LINE_CLEAR(20)
			gotoxy(0,20); sprintf(ConBuff, "Scan Type (S)ingle (T)wo channel: "); WRITE_CON
			cUserInputVal = (char)getch();
			if((cUserInputVal == 'D') || (cUserInputVal == 'd'))
			{
				fDone = TRUE;
				break;
			}

			bScanTypeTemp = cUserInputVal;
			if((bScanTypeTemp != 'S') && (bScanTypeTemp != 's') && (bScanTypeTemp != 'T') && (bScanTypeTemp != 't'))
			{
				gotoxy(0,20); sprintf(ConBuff, "Invalid Type entry  (any key to continue)"); WRITE_CON
				getch();
		 		continue;
			}

			switch(bScanTypeTemp)
			{
				case 'S': case 's':
					//6-18-01 apScanObject[usActiveScanDevIndex]->SO_bScanType = SINGLE_CHAN;
					//6-18-01
					bScanTypes[usActiveScanDevIndex] = SINGLE_CHAN;
					break;
				case 'T': case 't':
					//6-18-01 apScanObject[usActiveScanDevIndex]->SO_bScanType = TWO_CHAN;
					//6-18-01
					bScanTypes[usActiveScanDevIndex] = TWO_CHAN; 
					break;
				default: break;
			}

			break;
		}

		//6-18-01 if(apScanObject[usActiveScanDevIndex]->SO_bScanType == SINGLE_CHAN)
		//6-18-01
		if(bScanTypes[usActiveScanDevIndex] == SINGLE_CHAN)
		{
			ChanChange(usActiveScanDevID, aM301ConfigData[usActiveScanDevIndex].bChan, USER_INPUT_REQUIRED);
			LINE_CLEAR(18) LINE_CLEAR(24) // ChanChange writes to these lines
			gotoxy(0,19); sprintf(ConBuff, "D) Done"); WRITE_CON
			SetWin32CursorOn();
		}

		while(!fDone)
		{
			LINE_CLEAR(20)
			FlushConsoleInputBuffer(hInCon);
			gotoxy(0,20); sprintf(ConBuff, "Enter Rate: "); WRITE_CON

			/* 6-19-01
			cUserInputVal = (char)getch();
			if((cUserInputVal == 'D') || (cUserInputVal == 'd'))
			{
				fDone = TRUE;
				break;
			}
			FlushConsoleInputBuffer(hInCon);
			gets(caUserInputValString);
			if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd'))
			{
				fDone = TRUE;
				break;
			}

			dblRateTemp = atof(caUserInputValString);
			*/ //6-19-01


			//########################################
			//6-19-01 START OF ADDED #################
			iKeyIndex = 0;
			for(; (iKeyIndex < 80) && ((ch = getchar()) != EOF) && (ch != '\n' ); iKeyIndex++ )      
			KeyEntryBuff[iKeyIndex] = (char)ch; KeyEntryBuff[iKeyIndex] = '\0';

			for(BYTE bcIndex = 0; bcIndex < iKeyIndex; bcIndex++)
			{
				if((KeyEntryBuff[bcIndex] == 'D')  || (KeyEntryBuff[bcIndex] == 'd'))
				{ fDoneInput = TRUE; break; }
			}
			if(fDoneInput) { fDone = TRUE; break; }

			dblRateTemp = atof(KeyEntryBuff);
			//6-19-01 END OF ADDED   #################
			//########################################


			if((dblRateTemp < 50) || (dblRateTemp > 1000))
			{
				gotoxy(0,20); sprintf(ConBuff, "Invalid Rate entry..  (any key to continue)"); WRITE_CON
				getch();
				continue;
			}

			DOUBLE dblRate_SAVE = aM301ConfigData[usActiveScanDevIndex].dblRate;
			aM301ConfigData[usActiveScanDevIndex].dblRate = dblRateTemp;
			if(!SendRate(usDevID))
			{
				aM301ConfigData[usActiveScanDevIndex].dblRate = dblRate_SAVE;
				SetWin32CursorOff();
				LINE_CLEAR(20) LINE_CLEAR(19)
				return FALSE;
			}

			break;
		}

		break;
	}

	LINE_CLEAR(19)	LINE_CLEAR(20) LINE_CLEAR(24)

	SetWin32CursorOff();
	PrintScanMenuScreen();
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== STARTSCAN FUNCTION =========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN StartScan(USHORT usDevID)
{
	BOOLEAN fDevFound = FALSE;
	BYTE bCurDevIndex;
	for(bCurDevIndex = 0; bCurDevIndex < 64; bCurDevIndex++)
	{
		if(usLLABS_DeviceIDList[bCurDevIndex] == usDevID)
		{
			fDevFound = TRUE;
			break;
		}
	}
	if(!fDevFound)
	{
		gotoxy(0,20); sprintf(ConBuff, "DevID: %u Not found in list.  (any key to continue)", usDevID); WRITE_CON
		getch();
		return FALSE;
	}

	if(apScanObject[bCurDevIndex])
	{
		delete [] apScanObject[bCurDevIndex];
		apScanObject[bCurDevIndex] = NULL;
	}

	if(!AllocScanMem(usDevID))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed call to AllocScanMem(). Unable to scan."); WRITE_CON
		return FALSE;
	}
		
	if(!pDLL_StartScan(usDevID, apScanObject[bCurDevIndex], 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed call to DLL_StartScan(...)"); WRITE_CON
		return FALSE;
	}

	bDevScanning[bCurDevIndex] = SCANNING;
	if(!ReadScanData(usDevID))
	{
		CLEAR_MSG_LINE 
		if((apScanObject[bCurDevIndex]->SO_uiStatus) & SCAN_DEVICE_REMOVED)
		{
			sprintf(ConBuff, "Device was DISCONNECTED while scanning."); WRITE_CON
			MessageBox(hAppWindow, "\nScan device was removed.\n\n A device reset is required for this device\n\n Note that a device Reset may be done automatically during a reinitialization", "ERROR ----", MB_OK);
			
			USHORT usDevListArray[64]; usDevListArray[0] = usDevID; USHORT* pusDevListArray = usDevListArray;

			if(!pDLL_ReleaseDeviceFromIDList(pusDevListArray, FREE_ANY_DEV))
			{
				MessageBox(hAppWindow, "Failed call to DLL_ReleaseDeviceFromIDList(...)","IMPORTANT NOTICE", MB_OK);
			}
			
			return FALSE;  
		}

		if((apScanObject[bCurDevIndex]->SO_uiStatus) & SCAN_HALTED)
		{
			sprintf(ConBuff, "Device was HALTED while scanning."); WRITE_CON
			MessageBox(hAppWindow, "\nScan was halted for unknown reason.\n\n A device reset is recommended for this device\n\n Note that a device Reset may be done automatically during a reinitialization", "ERROR ----", MB_OK);
			return FALSE;  
		}

		sprintf(ConBuff, "Scan failed."); WRITE_CON
		EndScan(usDevID);
		return FALSE;
	}

	EndScan(usDevID);

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== READSCANDATA FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ReadScanData(USHORT usDevID)
{
	BYTE bDevIndex;

	// Following used for display and logfile purposes
	BYTE bCurChanOne = 0;

	for(bDevIndex = 0; bDevIndex < 64; bDevIndex++)
		if(usLLABS_DeviceIDList[bDevIndex] == usDevID) break;

	clock_t ClockEnd;
	clock_t ClockNoData;

	// Following MUST NOT be larger than SO_uiSizeVoltageArray should be 
	//  multiple of 10. See FuncDesc.doc for explanation. 
	//USHORT usNumScansToRead = 10;
	USHORT usNumScansToRead = (USHORT)((apScanObject[bDevIndex]->SO_dblRate) / 10);

	INT iRawCount = 0;
	DOUBLE dblVoltage, dblVoltageChan0;
	USHORT usLoopArrayIndex = 0;
	BYTE* pbHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;

	// The following is just used to avoid displaying every scan on the 
	//   screen, which is difficult to read at high scan rates.
	#define PRINT_FREQ (UINT)((apScanObject[bDevIndex]->SO_dblRate) / 1)
	UINT uiScanPrintCnt_0 = 0, uiScanPrintCnt_1 = 0;

	UINT* pDynaVoltageBuff = new UINT[apScanObject[bDevIndex]->SO_uiSizeVoltageArray];
	if(!pDynaVoltageBuff) return FALSE;

	BOOLEAN fDone = FALSE;
	char cUserInputVal = 0;

	gotoxy(0,23); sprintf(ConBuff, "E) End scan   D) Digital Output N) Channel Change"); WRITE_CON 
	CLEAR_MSG_LINE
	sprintf(ConBuff, "Scans Completed:            Scans In buffer:   "); WRITE_CON

	BOOLEAN fIsTwoChan = FALSE;

	// Following lines may still have display from previous scan.
	LINE_CLEAR(15) LINE_CLEAR(16) 

	switch(apScanObject[bDevIndex]->SO_bScanType)
	{
		case 1: 
			gotoxy(26,15);	 sprintf(ConBuff, "  Voltage Chan - %d: ", 
				aM301ConfigData[bDevIndex].bChan); WRITE_CON
			break;

		case 2:
			gotoxy(26,15);	 sprintf(ConBuff, "  Voltage Chan - 0: ", 
				aM301ConfigData[bDevIndex].bChan); WRITE_CON
			gotoxy(26,16);	 sprintf(ConBuff, "          Chan - 1: ", 
				aM301ConfigData[bDevIndex].bChan); WRITE_CON
			fIsTwoChan = TRUE;

			break;

		default: break;
	}

	// Scan data logfile setup
	char fBuff[128];
	UINT uiScanNum = 0;
	FILE *fpFile = NULL;
	#define FILE_WRITE fwrite(fBuff, 1,  strlen(fBuff), fpFile);

	if(fLogScansToFile)
	{
		uiScanNum = 0;
		fpFile = fopen( "ScanData.txt", "w+" );
		if(fpFile)
		{
			time_t lt; time( &lt ); sprintf(fBuff, "This log file created:  %s\n", ctime(&lt)); FILE_WRITE
			if(fIsTwoChan){ sprintf(fBuff, "Scan#\tChan - 0\t\tChan - 1\n\n"); FILE_WRITE }
			else{ sprintf(fBuff, "Scan#\tChan - %d\n\n", aM301ConfigData[usActiveScanDevIndex].bChan); FILE_WRITE }
		}
		else
			fLogScansToFile = FALSE;
	}

	ClockNoData = clock();

	while(!fDone)
	{
		while(!kbhit())
		{
			if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_DEVICE_REMOVED) break;

			if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_HALTED) break; 

			if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_CHECKSUM_ERROR) 
			{
				gotoxy(0,1); sprintf(ConBuff, " checksum error "); WRITE_CON
			}
			if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_MICRO_CODE_BUFF_WRAP) 
			{
				gotoxy(0,2); sprintf(ConBuff, " buffer wrap     "); WRITE_CON
			}

			if(bDevScanning[bDevIndex] == SCANNING)
			{
				if(!pDLL_ReadScanData(usDevID, pDynaVoltageBuff, usNumScansToRead, apScanObject[bDevIndex]))
				{ 
					//4-25-01 added clock stuff. This just causes an asterix to be displayed
					//  when there is no data for 1second. Keeps user from thinking things are
					//  locked up.
					if((clock() - ClockNoData) > 1000)
					{
						ClockNoData = clock();
						gotoxy(26,15); sprintf(ConBuff, "*"); WRITE_CON
					}
				}
				else
				{
					//4-25-01
					ClockNoData = clock();
					gotoxy(26,15); sprintf(ConBuff, " "); WRITE_CON

					for(usLoopArrayIndex = 0; usLoopArrayIndex < usNumScansToRead; usLoopArrayIndex++)
					{
						iRawCount = pDynaVoltageBuff[usLoopArrayIndex]; 
						dblVoltage = (iRawCount - 8388608) * 0.00000059604645;

						uiScanPrintCnt_0++; uiScanPrintCnt_1++; 

						if(fIsTwoChan)
						{
							// IMPORTANT NOTE: In two-channel scan mode, device ALWAYS takes 
							//   data from channel-0 first.

							// If channel-0 save it.
							if(!bCurChanOne)
							{
								// Save channel-0 data for logfile write next round
								dblVoltageChan0 = dblVoltage;

								// Less screen update if uncommented
								//if(uiScanPrintCnt_0 >= PRINT_FREQ )
								{
									gotoxy(44,15); sprintf(ConBuff, ": % 2.6lf", dblVoltage); WRITE_CON
								}
							}
							else	
							{
								// Less screen update if uncommented
								//if(uiScanPrintCnt_1 >= PRINT_FREQ )
								{
									uiScanPrintCnt_1 = 0;
									gotoxy(44,16); sprintf(ConBuff, ": %  2.6lf", dblVoltage); WRITE_CON 
								}
								uiScanNum ++;
								if(fLogScansToFile){ sprintf(fBuff, "%5u\t% 2.6lf\t% 2.6lf\n", uiScanNum, dblVoltageChan0, dblVoltage); FILE_WRITE }
							}
						}
						else
						{
							uiScanNum ++;
							if(uiScanPrintCnt_0 >= PRINT_FREQ ) { gotoxy(44,15);	 sprintf(ConBuff, ": %  2.6lf", dblVoltage);	WRITE_CON }
							if(fLogScansToFile){ sprintf(fBuff, "%5u\t% 2.6lf\n", uiScanNum, dblVoltage); FILE_WRITE }
						}

						// Less screen update if uncommented
						//if(uiScanPrintCnt_0 >= PRINT_FREQ )
						{
							if(fIsTwoChan)
							{
								gotoxy(17,24); sprintf(ConBuff, "%u", (apScanObject[bDevIndex]->SO_uiTotalPointsReadByDrvr) / 2); WRITE_CON
							}
							else
							{
								gotoxy(17,24); sprintf(ConBuff, "%u", apScanObject[bDevIndex]->SO_uiTotalPointsReadByDrvr); WRITE_CON
							}
							gotoxy(45,24); sprintf(ConBuff, "% 6u", apScanObject[bDevIndex]->SO_uiPointsInBuffer); WRITE_CON
						}

						// For log file formatting
						bCurChanOne ^= 1;
					}
				}

				// Use the following to empty the buffer if it is getting too full. Note that
				//  this should actually be put in a separate thread.
				// Set some reasonable values below to help clear the buffer if falling behind
				// Remember this must never be larger than SO_uiSizeVoltageArray.
				//usNumScansToRead = apScanObject[bDevIndex]->SO_uiPointsInBuffer;
				//if(usNumScansToRead < 10) usNumScansToRead = 10;
				//if(usNumScansToRead > 600) usNumScansToRead = 600;

				if(uiScanPrintCnt_0 >= PRINT_FREQ )
				{
					uiScanPrintCnt_0 = 0;
					bLastDigin = apScanObject[bDevIndex]->SO_bDigitalInput;
					DisplayDigin(bLastDigin);
				}

				uiScanPrintCnt_0++; uiScanPrintCnt_1++; 
			}
		}

		if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_DEVICE_REMOVED)
		{
			LINE_CLEAR(19)
			gotoxy(0,19); sprintf(ConBuff, "Scan SCAN_DEVICE_REMOVED for DevID: %d.  (any key to continue)", usDevID); WRITE_CON
			getch();
			LINE_CLEAR(19)
			SetWin32CursorOff();
			PrintScanMenuScreen();
			return FALSE;
		}
		if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_HALTED)
		{
			LINE_CLEAR(19)
			gotoxy(0,19); sprintf(ConBuff, "Scan HALTED for DevID: %d.  (any key to continue)", usDevID); WRITE_CON
			getch();
			LINE_CLEAR(19)
			ChanChange(usActiveDevID, aM301ConfigData[bActiveDevAsIndex].bChan, NO_USER_INPUT_REQUIRED);
			SetWin32CursorOff();
			PrintScanMenuScreen();
			return FALSE;
		}
		// end of added/modified


		cUserInputVal = (char)getch();

		switch(cUserInputVal)
		{
			case 'E': case 'e':
				fDone = TRUE;
				break;

			case 'D': case 'd':
				if(fIsTwoChan){
					// Need a brief delay since last write to device.
					ClockEnd = clock() + 20; while(clock() < ClockEnd);}

				DigitalOutput(usDevID);
				gotoxy(0,23); sprintf(ConBuff, "E) End scan   D) Digital Output"); WRITE_CON 
				CLEAR_MSG_LINE
				sprintf(ConBuff, "Scans Completed:            Scans In buffer:   "); WRITE_CON
				break;

			case 'N': case 'n':
				if(apScanObject[bDevIndex]->SO_bScanType == 1)
				{
					ChanChange(usDevID, aM301ConfigData[bDevIndex].bChan, USER_INPUT_REQUIRED);
					PrintScanMenuScreen();
					gotoxy(26,15);
					sprintf(ConBuff, "  Voltage Chan - %d: ", aM301ConfigData[bDevIndex].bChan); WRITE_CON

					gotoxy(0,23); sprintf(ConBuff, "E) End scan   D) Digital Output N) Channel Change"); WRITE_CON 
					CLEAR_MSG_LINE
					sprintf(ConBuff, "Scans Completed:            Scans In buffer:   "); WRITE_CON
				}
				break;

			default :
					break;
		}
	}

	if(fLogScansToFile) fclose(fpFile);

	LINE_CLEAR(23)
	gotoxy(0,23); sprintf(ConBuff, "                  "); WRITE_CON 
	CLEAR_MSG_LINE
	sprintf(ConBuff, "Please wait . . . ."); WRITE_CON

	delete [] pDynaVoltageBuff;

	if((apScanObject[bDevIndex]->SO_uiStatus) & SCAN_DEVICE_REMOVED)
		return FALSE;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== ENDSCAN FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN EndScan(USHORT usDevID)
{
	BYTE bDevIndex;
	for(bDevIndex = 0; bDevIndex < 64; bDevIndex++)
		if(usLLABS_DeviceIDList[bDevIndex] == usDevID) break;

	if(!pDLL_EndScan(usDevID, 0, 0, 0))
	{
		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Failed call to DLL_EndScan(...)"); WRITE_CON
		bDevScanning[bDevIndex] = NOT_SCANNING;
		if(fMsgPending)
			DispDLLMsg();
		return FALSE;
	}

	CLEAR_MSG_LINE 
	sprintf(ConBuff, "Scan ended"); WRITE_CON

	bDevScanning[bDevIndex] = NOT_SCANNING;

	if(apScanObject[bDevIndex])
	{
		delete [] apScanObject[bDevIndex];
		apScanObject[bDevIndex] = NULL;
	}

	// The following is changed by device at end of scan. The device does a new signon
	//   and system calibration, and sets channel to 0 in the process
	ChanChange(usActiveDevID, aM301ConfigData[bActiveDevAsIndex].bChan, NO_USER_INPUT_REQUIRED);

	//Channel change wrote to screen, so get rid of it.
	//gotoxy(46,20);	sprintf(ConBuff, "         "); WRITE_CON 
	SetWin32CursorOff();
	PrintScanMenuScreen();

	return TRUE;
}
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************







//--- M I S C E L L A N E O U S   F U N C T I O N S -------------







//***************************************************************
//*--- M I S C E L L A N E O U S   F U N C T I O N S ------------\
//****************************************************************\
//================================================================*\
//==== PRINTDEVICESAVAILABLE FUNCTION =============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintDevicesAvailable()
{
	BOOLEAN fDevFound = FALSE;
	BYTE bTempIndexPtr = 0;
	BYTE bCurIndex;
	char szDevAvailBuff[128];
	char szBuffTemp[32];
	sprintf(szDevAvailBuff, "Found DevID:  ");

	for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
	{
		if(usLLABS_DeviceIDList[bCurIndex])
		{
			sprintf(szBuffTemp, "%u   ", usLLABS_DeviceIDList[bCurIndex]);
			strcat(szDevAvailBuff, szBuffTemp);
			fDevFound = TRUE;
		}
	}

	if(!fDevFound) sprintf(szDevAvailBuff, "No Devices were found");
	
	CLEAR_MSG_LINE 
	sprintf(ConBuff, szDevAvailBuff); WRITE_CON
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== DISPLAYDIGIN FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN DisplayDigin(BYTE bLastDigin)
{
	gotoxy(0,22); sprintf(ConBuff, "Last Digital Input: %d", bLastDigin); WRITE_CON
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== FREEDEVICEFROMLIST FUNCTION ================================*>
//================================================================*/
/*****************************************************************/

BOOLEAN FreeDeviceFromList()
{
	char caUserInputValString[32];
	char cUserInputVal = 0;

	BYTE bDevIndex, bTotDevicesStillAvailable, bIndex;
	USHORT usDevID, usaDevListArray[64];
	USHORT *pusDevListArray = usaDevListArray;
	BOOLEAN fDevFound, fDone;

	if(!fInitialized)
	{
		if(!LoadLibraries()){
			MessageBox(hAppWindow, "\nLoadLibraries() failed.\n\n Will not be able to perform this task", "ERROR ----", MB_OK);
			return FALSE;}

		//---------->
		pDLL_Init = (P_DLL_INIT)GetProcAddress(hLibLL_USB, "DLL_Init");
		//---------->
		if(!pDLL_Init)
		{
			if(fWin98Flag)
				MessageBox(hAppWindow, "failed to find function:\n     DLL_Init(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
			else
				MessageBox(hAppWindow, "failed to find function:\n     DLL_Init(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
			return FALSE;
		}

		pusLLABS_DeviceIDList = usLLABS_DeviceIDList;
		pbUnusedVar = bUnusedValues;

		if(!pDLL_Init(hAppWindow, hUnused, hUnused, sDebugLevel, &bNumDevices, pbUnusedVar, pusLLABS_DeviceIDList))
		{
			CLEAR_MSG_LINE 
			sprintf(ConBuff, "Failed call to DLL_Init(...)"); WRITE_CON
			return FALSE;
		}

		CLEAR_MSG_LINE 
		sprintf(ConBuff, "Succeeded call to DLL_Init(...)"); WRITE_CON

		if(!pDLL_ReleaseDeviceFromIDList)
		{
			//---------->
			pDLL_ReleaseDeviceFromIDList = (P_DLL_RELEASE_DEVICE_FROM_IDLIST)GetProcAddress(hLibLL_USB, "DLL_ReleaseDeviceFromIDList");
			//---------->
			if(!pDLL_ReleaseDeviceFromIDList)
			{
				if(fWin98Flag)
					MessageBox(hAppWindow, "failed to find function:\n     DLL_ReleaseDeviceFromIDList(...) \nin LL_USB.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
				else
					MessageBox(hAppWindow, "failed to find function:\n     DLL_ReleaseDeviceFromIDList(...) \nin LL_USB2K.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
				return FALSE;
			}
		}
	}

	for(bDevIndex = 0; bDevIndex < 64; bDevIndex++) usaDevListArray[bDevIndex] = 0;

	CLEAR_MSG_LINE 
	gotoxy(0,16); sprintf(ConBuff, "********************************************************************************"); WRITE_CON
	gotoxy(22,17); sprintf(ConBuff, "-------- Free Device Handling --------"); WRITE_CON

	SetWin32CursorOn();

	fDone = FALSE;
	while(!fDone)
	{
		LINE_CLEAR(19)
		fDevFound = FALSE;
		gotoxy(0,20); sprintf(ConBuff, "D) Done          Enter DevId in decimal format"); WRITE_CON
		gotoxy(0,19); sprintf(ConBuff, "Enter Device ID: "); WRITE_CON
		FlushConsoleInputBuffer(hInCon);
		gets(caUserInputValString);
		if((caUserInputValString[0] == 'D') || (caUserInputValString[0] == 'd')) break;
		usDevID = (USHORT)atoi(caUserInputValString);

		if(usDevID == 0)
		{
			LINE_CLEAR(19)
			gotoxy(0,19); sprintf(ConBuff, "Invalid Device ID: %s.  (any key to continue)", caUserInputValString); WRITE_CON
			getch();
			LINE_CLEAR(19)
			continue;
		}

		gotoxy(0,19); sprintf(ConBuff, "Remove Device ID: %u  (Y)es  (N)o? ", usDevID); WRITE_CON
		
		while((cUserInputVal != 'Y') && (cUserInputVal != 'y') && (cUserInputVal != 'N') && (cUserInputVal != 'n'))
		{
			cUserInputVal = (char)getch();
		}

		if((cUserInputVal == 'Y') || (cUserInputVal == 'y'))
		{
			pusDevListArray[0] = usDevID;

			if(!pDLL_ReleaseDeviceFromIDList(pusDevListArray, FREE_ANY_DEV))
			{
				MessageBox(hAppWindow, "Failed call to DLL_ReleaseDeviceFromIDList(...)","IMPORTANT NOTICE", MB_OK);
			}
			else if(fInitialized)
			{
				bTotDevicesStillAvailable = 0;
				for(bIndex = 0; bIndex < 64; bIndex++)
					if(usLLABS_DeviceIDList[bIndex] == usDevID)
						usLLABS_DeviceIDList[bIndex] = 0;
				for(bIndex = 0; bIndex < 64; bIndex++)
					if(usLLABS_DeviceIDList[bIndex])
					{
						bTotDevicesStillAvailable++;
						pusDevListArray[bIndex] = usLLABS_DeviceIDList[bIndex];
					}
				bNumDevices = bTotDevicesStillAvailable;
			}
		}
	}

	if(!bNumDevices)
		fInitialized = FALSE;

	SetWin32CursorOff();   		
	LINE_CLEAR(16)	LINE_CLEAR(17) LINE_CLEAR(19) LINE_CLEAR(20)

	PrintUtilityMenuScreen();

	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== CLEANUPBEFOREEXIT FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN CleanupBeforeExit()
{
	if(fInitialized  || fNeedToFreeListOnExit)
	{
		BYTE bCurIndex = 0;

		if(!pDLL_ReleaseDeviceFromIDList(pusLLABS_DeviceIDList, FREE_ONLY_APP_OWNED_DEVICES))
		{
			MessageBox(hAppWindow, "Failed call to DLL_ReleaseDeviceFromIDList(...)", "IMPORTANT NOTICE", MB_OK);
		}

		for(bCurIndex = 0; bCurIndex < 64; bCurIndex++)
		{
			if(apScanObject[bCurIndex])
				delete [] apScanObject[bCurIndex];
		}
	}

	//3-21-01
	if(hMainWinDlg) 
	{ 
		EndDialog(hMainWinDlg, 1); hMainWinDlg = NULL; 
	}

	FreeLibrary (hLibLL_USB);

	return TRUE;
}


BOOLEAN GetWinVerInfo()
{
	OSVERSIONINFO structOS_ver;
	structOS_ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&structOS_ver);

	while(TRUE)
	{
		//VER_PLATFORM_WIN32s			Win32s on Windows 3.1. 
		//VER_PLATFORM_WIN32_WINDOWS  Win32 on Windows 95. 
		//VER_PLATFORM_WIN32_NT		Win32 on Windows NT. 
		if(structOS_ver.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
		{
			fWin98Flag = TRUE;
			break;
		}
		fWin98Flag = FALSE;
		break;
	}
	return TRUE;
}





//****************************************************************\
//================================================================*\
//==== DLG_DLGPROC FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
/* FOR IN-HOUSE TESTING ONLY
BOOL CALLBACK DLG_DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	BYTE bIndex = 0;
	switch(uMsg) { case WM_INITDIALOG: return TRUE; case WM_COMMAND: switch(LOWORD(wParam)) { case IDOK: break; } }
	return FALSE;
}
*/


//****************************************************************\
//================================================================*\
//==== MAKEDIALOG FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
/* FOR IN-HOUSE TESTING ONLY
BOOLEAN MakeDialog()
{
	hMainWinDlg = CreateDialog(0, MAKEINTRESOURCE( IDD_DIALOG1 ), GetDesktopWindow(), (DLGPROC)DLG_DlgProc); 
	if(hMainWinDlg!=NULL) ShowWindow(hMainWinDlg,SW_HIDE);
	else MessageBox(0, "FAILED TO CREATE DIALOG", "IMPORTANT NOTICE ---", MB_OK);
	return TRUE;
}
*/

/* FOR IN-HOUSE TESTING ONLY 
VOID CALLBACK HandleDLLMsg(char* szMsgFromDLL);
typedef VOID(*P_DLL_MESSAGING_WINDOW_FUNC)(char *msg);

typedef HANDLE(*P_DLL_SET_APP_MESSAGING)(BOOLEAN fEnable, P_DLL_MESSAGING_WINDOW_FUNC pMessagingWindowFunc);
P_DLL_SET_APP_MESSAGING pDLL_SetAppMessaging;

VOID CALLBACK HandleDLLMsg(char* szMsgFromDLL)

{
	MessageBox(0, szMsgFromDLL, "MESSAGE FROM DLL", MB_OK);
}


BOOLEAN TempFunc(void)
{

	pDLL_SetAppMessaging = (P_DLL_SET_APP_MESSAGING)GetProcAddress(hLibLL_USB, "DLL_SetAppMessaging_CPP");
	if(!pDLL_SetAppMessaging)
	{
	  MessageBox(0, "failed to find function:\n     DLL_SetAppMessaging_CPP(...)" "\nin M301.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
	  return FALSE;
	}

	#define DO_DLL_MESSAGING TRUE
	if(!pDLL_SetAppMessaging(DO_DLL_MESSAGING, HandleDLLMsg))
	{
	  MessageBox(0, "UNABLE TO SET DLL MESSAGING", "IMPORTANT NOTICE ---", MB_OK);
	  return FALSE;
	}

	return TRUE;
}
*/

